/[gentoo-x86]/eclass/python.eclass
Gentoo

Diff of /eclass/python.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.95 Revision 1.105
1# Copyright 1999-2010 Gentoo Foundation 1# Copyright 1999-2010 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/python.eclass,v 1.95 2010/03/20 17:59:40 arfrever Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/python.eclass,v 1.105 2010/10/29 19:09:08 arfrever Exp $
4 4
5# @ECLASS: python.eclass 5# @ECLASS: python.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Gentoo Python Project <python@gentoo.org> 7# Gentoo Python Project <python@gentoo.org>
8# @BLURB: Eclass for Python packages 8# @BLURB: Eclass for Python packages
16fi 16fi
17 17
18_CPYTHON2_SUPPORTED_ABIS=(2.4 2.5 2.6 2.7) 18_CPYTHON2_SUPPORTED_ABIS=(2.4 2.5 2.6 2.7)
19_CPYTHON3_SUPPORTED_ABIS=(3.0 3.1 3.2) 19_CPYTHON3_SUPPORTED_ABIS=(3.0 3.1 3.2)
20_JYTHON_SUPPORTED_ABIS=(2.5-jython) 20_JYTHON_SUPPORTED_ABIS=(2.5-jython)
21_PYTHON_SUPPORTED_ABIS=(${_CPYTHON2_SUPPORTED_ABIS[@]} ${_CPYTHON3_SUPPORTED_ABIS[@]} ${_JYTHON_SUPPORTED_ABIS[@]})
22
23# ================================================================================================
24# ===================================== HANDLING OF METADATA =====================================
25# ================================================================================================
21 26
22# @ECLASS-VARIABLE: PYTHON_DEPEND 27# @ECLASS-VARIABLE: PYTHON_DEPEND
23# @DESCRIPTION: 28# @DESCRIPTION:
24# Specification of dependency on dev-lang/python. 29# Specification of dependency on dev-lang/python.
25# Syntax: 30# Syntax:
27# version_components_group: <major_version[:[minimal_version][:maximal_version]]> 32# version_components_group: <major_version[:[minimal_version][:maximal_version]]>
28# major_version: <2|3|*> 33# major_version: <2|3|*>
29# minimal_version: <minimal_major_version.minimal_minor_version> 34# minimal_version: <minimal_major_version.minimal_minor_version>
30# maximal_version: <maximal_major_version.maximal_minor_version> 35# maximal_version: <maximal_major_version.maximal_minor_version>
31 36
32_parse_PYTHON_DEPEND() { 37_python_parse_PYTHON_DEPEND() {
33 local major_version maximal_version minimal_version python_all="0" python_maximal_version python_minimal_version python_versions=() python2="0" python2_maximal_version python2_minimal_version python3="0" python3_maximal_version python3_minimal_version USE_flag= version_components_group version_components_group_regex version_components_groups 38 local major_version maximal_version minimal_version python_all="0" python_maximal_version python_minimal_version python_versions=() python2="0" python2_maximal_version python2_minimal_version python3="0" python3_maximal_version python3_minimal_version USE_flag= version_components_group version_components_group_regex version_components_groups
34 39
35 version_components_group_regex="(2|3|\*)(:([[:digit:]]+\.[[:digit:]]+)?(:([[:digit:]]+\.[[:digit:]]+)?)?)?" 40 version_components_group_regex="(2|3|\*)(:([[:digit:]]+\.[[:digit:]]+)?(:([[:digit:]]+\.[[:digit:]]+)?)?)?"
36 version_components_groups="${PYTHON_DEPEND}" 41 version_components_groups="${PYTHON_DEPEND}"
37 42
153} 158}
154 159
155DEPEND=">=app-admin/eselect-python-20091230" 160DEPEND=">=app-admin/eselect-python-20091230"
156RDEPEND="${DEPEND}" 161RDEPEND="${DEPEND}"
157 162
158if [[ -n "${PYTHON_DEPEND}" && -n "${NEED_PYTHON}" ]]; then
159 die "PYTHON_DEPEND and NEED_PYTHON cannot be set simultaneously"
160elif [[ -n "${PYTHON_DEPEND}" ]]; then 163if [[ -n "${PYTHON_DEPEND}" ]]; then
161 _parse_PYTHON_DEPEND 164 _python_parse_PYTHON_DEPEND
162elif [[ -n "${NEED_PYTHON}" ]]; then
163 if ! has "${EAPI:-0}" 0 1 2; then
164 eerror "Use PYTHON_DEPEND instead of NEED_PYTHON."
165 die "NEED_PYTHON cannot be used in this EAPI"
166 fi
167 _PYTHON_ATOMS=(">=dev-lang/python-${NEED_PYTHON}")
168 DEPEND+="${DEPEND:+ }${_PYTHON_ATOMS[@]}"
169 RDEPEND+="${RDEPEND:+ }${_PYTHON_ATOMS[@]}"
170else 165else
171 _PYTHON_ATOMS=("dev-lang/python") 166 _PYTHON_ATOMS=("dev-lang/python")
172fi 167fi
168unset -f _python_parse_PYTHON_DEPEND
169
170if [[ -n "${NEED_PYTHON}" ]]; then
171 eerror "Use PYTHON_DEPEND variable instead of NEED_PYTHON variable."
172 die "NEED_PYTHON variable is banned"
173fi
173 174
174# @ECLASS-VARIABLE: PYTHON_USE_WITH 175# @ECLASS-VARIABLE: PYTHON_USE_WITH
175# @DESCRIPTION: 176# @DESCRIPTION:
176# Set this to a space separated list of USE flags the Python slot in use must be built with. 177# Set this to a space separated list of USE flags the Python slot in use must be built with.
177 178
182# @ECLASS-VARIABLE: PYTHON_USE_WITH_OPT 183# @ECLASS-VARIABLE: PYTHON_USE_WITH_OPT
183# @DESCRIPTION: 184# @DESCRIPTION:
184# Set this to a name of a USE flag if you need to make either PYTHON_USE_WITH or 185# Set this to a name of a USE flag if you need to make either PYTHON_USE_WITH or
185# PYTHON_USE_WITH_OR atoms conditional under a USE flag. 186# PYTHON_USE_WITH_OR atoms conditional under a USE flag.
186 187
187# @FUNCTION: python_pkg_setup
188# @DESCRIPTION:
189# Makes sure PYTHON_USE_WITH or PYTHON_USE_WITH_OR listed use flags
190# are respected. Only exported if one of those variables is set.
191if ! has "${EAPI:-0}" 0 1 && [[ -n ${PYTHON_USE_WITH} || -n ${PYTHON_USE_WITH_OR} ]]; then 188if ! has "${EAPI:-0}" 0 1 && [[ -n ${PYTHON_USE_WITH} || -n ${PYTHON_USE_WITH_OR} ]]; then
192 python_pkg_setup() {
193 # Check if phase is pkg_setup().
194 [[ "${EBUILD_PHASE}" != "setup" ]] && die "${FUNCNAME}() can be used only in pkg_setup() phase"
195
196 python_pkg_setup_fail() {
197 eerror "${1}"
198 die "${1}"
199 }
200
201 if [[ "${PYTHON_USE_WITH_OPT}" ]]; then
202 if [[ "${PYTHON_USE_WITH_OPT}" == !* ]]; then
203 use ${PYTHON_USE_WITH_OPT#!} && return
204 else
205 use !${PYTHON_USE_WITH_OPT} && return
206 fi
207 fi
208
209 python_pkg_setup_check_USE_flags() {
210 local pyatom use
211 pyatom="$(python_get_implementational_package)"
212
213 for use in ${PYTHON_USE_WITH}; do
214 if ! has_version "${pyatom}[${use}]"; then
215 python_pkg_setup_fail "Please rebuild ${pyatom} with the following USE flags enabled: ${PYTHON_USE_WITH}"
216 fi
217 done
218
219 for use in ${PYTHON_USE_WITH_OR}; do
220 if has_version "${pyatom}[${use}]"; then
221 return
222 fi
223 done
224
225 if [[ ${PYTHON_USE_WITH_OR} ]]; then
226 python_pkg_setup_fail "Please rebuild ${pyatom} with at least one of the following USE flags enabled: ${PYTHON_USE_WITH_OR}"
227 fi
228 }
229
230 if _python_package_supporting_installation_for_multiple_python_abis; then
231 python_execute_function -q python_pkg_setup_check_USE_flags
232 else
233 python_pkg_setup_check_USE_flags
234 fi
235
236 unset -f python_pkg_setup_check_USE_flags python_pkg_setup_fail
237 }
238
239 EXPORT_FUNCTIONS pkg_setup
240
241 _PYTHON_USE_WITH_ATOMS_ARRAY=() 189 _PYTHON_USE_WITH_ATOMS_ARRAY=()
242 if [[ -n "${PYTHON_USE_WITH}" ]]; then 190 if [[ -n "${PYTHON_USE_WITH}" ]]; then
243 for _PYTHON_ATOM in "${_PYTHON_ATOMS[@]}"; do 191 for _PYTHON_ATOM in "${_PYTHON_ATOMS[@]}"; do
244 _PYTHON_USE_WITH_ATOMS_ARRAY+=("${_PYTHON_ATOM}[${PYTHON_USE_WITH/ /,}]") 192 _PYTHON_USE_WITH_ATOMS_ARRAY+=("${_PYTHON_ATOM}[${PYTHON_USE_WITH// /,}]")
245 done 193 done
246 elif [[ -n "${PYTHON_USE_WITH_OR}" ]]; then 194 elif [[ -n "${PYTHON_USE_WITH_OR}" ]]; then
247 for _USE_flag in ${PYTHON_USE_WITH_OR}; do 195 for _USE_flag in ${PYTHON_USE_WITH_OR}; do
248 for _PYTHON_ATOM in "${_PYTHON_ATOMS[@]}"; do 196 for _PYTHON_ATOM in "${_PYTHON_ATOMS[@]}"; do
249 _PYTHON_USE_WITH_ATOMS_ARRAY+=("${_PYTHON_ATOM}[${_USE_flag}]") 197 _PYTHON_USE_WITH_ATOMS_ARRAY+=("${_PYTHON_ATOM}[${_USE_flag}]")
265fi 213fi
266 214
267unset _PYTHON_ATOMS 215unset _PYTHON_ATOMS
268 216
269# ================================================================================================ 217# ================================================================================================
218# =================================== MISCELLANEOUS FUNCTIONS ====================================
219# ================================================================================================
220
221_python_implementation() {
222 if [[ "${CATEGORY}/${PN}" == "dev-lang/python" ]]; then
223 return 0
224 elif [[ "${CATEGORY}/${PN}" == "dev-java/jython" ]]; then
225 return 0
226 else
227 return 1
228 fi
229}
230
231_python_package_supporting_installation_for_multiple_python_abis() {
232 if [[ "${EBUILD_PHASE}" == "depend" ]]; then
233 die "${FUNCNAME}() cannot be used in global scope"
234 fi
235
236 if has "${EAPI:-0}" 0 1 2 3 4; then
237 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
238 return 0
239 else
240 return 1
241 fi
242 else
243 die "${FUNCNAME}(): Support for EAPI=\"${EAPI}\" not implemented"
244 fi
245}
246
247_python_abi-specific_local_scope() {
248 [[ " ${FUNCNAME[@]:2} " =~ " "(_python_final_sanity_checks|python_execute_function|python_mod_optimize|python_mod_cleanup)" " ]]
249}
250
251_python_initialize_prefix_variables() {
252 if has "${EAPI:-0}" 0 1 2; then
253 if [[ -n "${ROOT}" && -z "${EROOT}" ]]; then
254 EROOT="${ROOT%/}${EPREFIX}/"
255 fi
256 if [[ -n "${D}" && -z "${ED}" ]]; then
257 ED="${D%/}${EPREFIX}/"
258 fi
259 fi
260}
261
262unset PYTHON_SANITY_CHECKS_EXECUTED PYTHON_SKIP_SANITY_CHECKS
263
264_python_initial_sanity_checks() {
265 if [[ "$(declare -p PYTHON_SANITY_CHECKS_EXECUTED 2> /dev/null)" != "declare -- PYTHON_SANITY_CHECKS_EXECUTED="* || " ${FUNCNAME[@]:1} " =~ " "(python_set_active_version|python_pkg_setup)" " && -z "${PYTHON_SKIP_SANITY_CHECKS}" ]]; then
266 # Ensure that /usr/bin/python and /usr/bin/python-config are valid.
267 if [[ "$(readlink "${EPREFIX}/usr/bin/python")" != "python-wrapper" ]]; then
268 eerror "'${EPREFIX}/usr/bin/python' is not valid symlink."
269 eerror "Use \`eselect python set \${python_interpreter}\` to fix this problem."
270 die "'${EPREFIX}/usr/bin/python' is not valid symlink"
271 fi
272 if [[ "$(<"${EPREFIX}/usr/bin/python-config")" != *"Gentoo python-config wrapper script"* ]]; then
273 eerror "'${EPREFIX}/usr/bin/python-config' is not valid script"
274 eerror "Use \`eselect python set \${python_interpreter}\` to fix this problem."
275 die "'${EPREFIX}/usr/bin/python-config' is not valid script"
276 fi
277 fi
278}
279
280_python_final_sanity_checks() {
281 if ! _python_implementation && [[ "$(declare -p PYTHON_SANITY_CHECKS_EXECUTED 2> /dev/null)" != "declare -- PYTHON_SANITY_CHECKS_EXECUTED="* || " ${FUNCNAME[@]:1} " =~ " "(python_set_active_version|python_pkg_setup)" " && -z "${PYTHON_SKIP_SANITY_CHECKS}" ]]; then
282 local PYTHON_ABI="${PYTHON_ABI}"
283 for PYTHON_ABI in ${PYTHON_ABIS-${PYTHON_ABI}}; do
284 # Ensure that appropriate version of Python is installed.
285 if ! has_version "$(python_get_implementational_package)"; then
286 die "$(python_get_implementational_package) is not installed"
287 fi
288
289 # Ensure that EPYTHON variable is respected.
290 if [[ "$(EPYTHON="$(PYTHON)" python -c "${_PYTHON_ABI_EXTRACTION_COMMAND}")" != "${PYTHON_ABI}" ]]; then
291 eerror "Path to 'python': '$(type -p python)'"
292 eerror "ABI: '${ABI}'"
293 eerror "DEFAULT_ABI: '${DEFAULT_ABI}'"
294 eerror "EPYTHON: '$(PYTHON)'"
295 eerror "PYTHON_ABI: '${PYTHON_ABI}'"
296 eerror "Locally active version of Python: '$(EPYTHON="$(PYTHON)" python -c "${_PYTHON_ABI_EXTRACTION_COMMAND}")'"
297 die "'python' does not respect EPYTHON variable"
298 fi
299 done
300 fi
301 PYTHON_SANITY_CHECKS_EXECUTED="1"
302}
303
304# @ECLASS-VARIABLE: PYTHON_COLORS
305# @DESCRIPTION:
306# User-configurable colored output.
307PYTHON_COLORS="${PYTHON_COLORS:-0}"
308
309_python_set_color_variables() {
310 if [[ "${PYTHON_COLORS}" != "0" && "${NOCOLOR:-false}" =~ ^(false|no)$ ]]; then
311 _BOLD=$'\e[1m'
312 _RED=$'\e[1;31m'
313 _GREEN=$'\e[1;32m'
314 _BLUE=$'\e[1;34m'
315 _CYAN=$'\e[1;36m'
316 _NORMAL=$'\e[0m'
317 else
318 _BOLD=
319 _RED=
320 _GREEN=
321 _BLUE=
322 _CYAN=
323 _NORMAL=
324 fi
325}
326
327unset PYTHON_PKG_SETUP_EXECUTED
328
329_python_check_python_pkg_setup_execution() {
330 [[ " ${FUNCNAME[@]:1} " =~ " "(python_set_active_version|python_pkg_setup)" " ]] && return
331
332 if ! has "${EAPI:-0}" 0 1 2 3 && [[ -z "${PYTHON_PKG_SETUP_EXECUTED}" ]]; then
333 die "python_pkg_setup() not called"
334 fi
335}
336
337# @FUNCTION: python_pkg_setup
338# @DESCRIPTION:
339# Perform sanity checks and initialize environment.
340#
341# This function is exported in EAPI 2 and 3 when PYTHON_USE_WITH or PYTHON_USE_WITH_OR variable
342# is set and always in EAPI >=4. Calling of this function is mandatory in EAPI >=4.
343#
344# This function can be used only in pkg_setup() phase.
345python_pkg_setup() {
346 # Check if phase is pkg_setup().
347 [[ "${EBUILD_PHASE}" != "setup" ]] && die "${FUNCNAME}() can be used only in pkg_setup() phase"
348
349 if [[ "$#" -ne 0 ]]; then
350 die "${FUNCNAME}() does not accept arguments"
351 fi
352
353 if _python_package_supporting_installation_for_multiple_python_abis; then
354 _python_calculate_PYTHON_ABIS
355 export EPYTHON="$(PYTHON -f)"
356 else
357 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
358 fi
359
360 if ! has "${EAPI:-0}" 0 1 && [[ -n "${PYTHON_USE_WITH}" || -n "${PYTHON_USE_WITH_OR}" ]]; then
361 if [[ "${PYTHON_USE_WITH_OPT}" ]]; then
362 if [[ "${PYTHON_USE_WITH_OPT}" == !* ]]; then
363 use ${PYTHON_USE_WITH_OPT#!} && return
364 else
365 use !${PYTHON_USE_WITH_OPT} && return
366 fi
367 fi
368
369 python_pkg_setup_check_USE_flags() {
370 local python_atom USE_flag
371 python_atom="$(python_get_implementational_package)"
372
373 for USE_flag in ${PYTHON_USE_WITH}; do
374 if ! has_version "${python_atom}[${USE_flag}]"; then
375 eerror "Please rebuild ${python_atom} with the following USE flags enabled: ${PYTHON_USE_WITH}"
376 die "Please rebuild ${python_atom} with the following USE flags enabled: ${PYTHON_USE_WITH}"
377 fi
378 done
379
380 for USE_flag in ${PYTHON_USE_WITH_OR}; do
381 if has_version "${python_atom}[${USE_flag}]"; then
382 return
383 fi
384 done
385
386 if [[ ${PYTHON_USE_WITH_OR} ]]; then
387 eerror "Please rebuild ${python_atom} with at least one of the following USE flags enabled: ${PYTHON_USE_WITH_OR}"
388 die "Please rebuild ${python_atom} with at least one of the following USE flags enabled: ${PYTHON_USE_WITH_OR}"
389 fi
390 }
391
392 if _python_package_supporting_installation_for_multiple_python_abis; then
393 PYTHON_SKIP_SANITY_CHECKS="1" python_execute_function -q python_pkg_setup_check_USE_flags
394 else
395 python_pkg_setup_check_USE_flags
396 fi
397
398 unset -f python_pkg_setup_check_USE_flags
399 fi
400
401 PYTHON_PKG_SETUP_EXECUTED="1"
402}
403
404if ! has "${EAPI:-0}" 0 1 2 3 || { has "${EAPI:-0}" 2 3 && [[ -n "${PYTHON_USE_WITH}" || -n "${PYTHON_USE_WITH_OR}" ]]; }; then
405 EXPORT_FUNCTIONS pkg_setup
406fi
407
408# @FUNCTION: python_convert_shebangs
409# @USAGE: [-q|--quiet] [-r|--recursive] [-x|--only-executables] [--] <Python_version> <file|directory> [files|directories]
410# @DESCRIPTION:
411# Convert shebangs in specified files. Directories can be specified only with --recursive option.
412python_convert_shebangs() {
413 _python_check_python_pkg_setup_execution
414
415 local argument file files=() only_executables="0" python_version quiet="0" recursive="0"
416
417 while (($#)); do
418 case "$1" in
419 -r|--recursive)
420 recursive="1"
421 ;;
422 -q|--quiet)
423 quiet="1"
424 ;;
425 -x|--only-executables)
426 only_executables="1"
427 ;;
428 --)
429 shift
430 break
431 ;;
432 -*)
433 die "${FUNCNAME}(): Unrecognized option '$1'"
434 ;;
435 *)
436 break
437 ;;
438 esac
439 shift
440 done
441
442 if [[ "$#" -eq 0 ]]; then
443 die "${FUNCNAME}(): Missing Python version and files or directories"
444 elif [[ "$#" -eq 1 ]]; then
445 die "${FUNCNAME}(): Missing files or directories"
446 fi
447
448 python_version="$1"
449 shift
450
451 for argument in "$@"; do
452 if [[ ! -e "${argument}" ]]; then
453 die "${FUNCNAME}(): '${argument}' does not exist"
454 elif [[ -f "${argument}" ]]; then
455 files+=("${argument}")
456 elif [[ -d "${argument}" ]]; then
457 if [[ "${recursive}" == "1" ]]; then
458 while read -d $'\0' -r file; do
459 files+=("${file}")
460 done < <(find "${argument}" $([[ "${only_executables}" == "1" ]] && echo -perm /111) -type f -print0)
461 else
462 die "${FUNCNAME}(): '${argument}' is not a regular file"
463 fi
464 else
465 die "${FUNCNAME}(): '${argument}' is not a regular file or a directory"
466 fi
467 done
468
469 for file in "${files[@]}"; do
470 file="${file#./}"
471 [[ "${only_executables}" == "1" && ! -x "${file}" ]] && continue
472
473 if [[ "$(head -n1 "${file}")" =~ ^'#!'.*python ]]; then
474 [[ "$(sed -ne "2p" "${file}")" =~ ^"# Gentoo '".*"' wrapper script generated by python_generate_wrapper_scripts()"$ ]] && continue
475
476 if [[ "${quiet}" == "0" ]]; then
477 einfo "Converting shebang in '${file}'"
478 fi
479
480 sed -e "1s/python\([[:digit:]]\+\(\.[[:digit:]]\+\)\?\)\?/python${python_version}/" -i "${file}" || die "Conversion of shebang in '${file}' failed"
481
482 # Delete potential whitespace after "#!".
483 sed -e '1s/\(^#!\)[[:space:]]*/\1/' -i "${file}" || die "sed '${file}' failed"
484 fi
485 done
486}
487
488# @FUNCTION: python_clean_installation_image
489# @USAGE: [-q|--quiet]
490# @DESCRIPTION:
491# Delete needless files in installation image.
492python_clean_installation_image() {
493 _python_check_python_pkg_setup_execution
494 _python_initialize_prefix_variables
495
496 local file files=() quiet="0"
497
498 # Check if phase is src_install().
499 [[ "${EBUILD_PHASE}" != "install" ]] && die "${FUNCNAME}() can be used only in src_install() phase"
500
501 while (($#)); do
502 case "$1" in
503 -q|--quiet)
504 quiet="1"
505 ;;
506 -*)
507 die "${FUNCNAME}(): Unrecognized option '$1'"
508 ;;
509 *)
510 die "${FUNCNAME}(): Invalid usage"
511 ;;
512 esac
513 shift
514 done
515
516 while read -d $'\0' -r file; do
517 files+=("${file}")
518 done < <(find "${ED}" "(" -name "*.py[co]" -o -name "*\$py.class" ")" -type f -print0)
519
520 if [[ "${#files[@]}" -gt 0 ]]; then
521 if [[ "${quiet}" == "0" ]]; then
522 ewarn "Deleting byte-compiled Python modules needlessly generated by build system:"
523 fi
524 for file in "${files[@]}"; do
525 if [[ "${quiet}" == "0" ]]; then
526 ewarn " ${file}"
527 fi
528 rm -f "${file}"
529
530 # Delete empty __pycache__ directories.
531 if [[ "${file%/*}" == *"/__pycache__" ]]; then
532 rmdir "${file%/*}" 2> /dev/null
533 fi
534 done
535 fi
536
537 python_clean_sitedirs() {
538 if [[ -d "${ED}$(python_get_sitedir)" ]]; then
539 find "${ED}$(python_get_sitedir)" "(" -name "*.c" -o -name "*.h" -o -name "*.la" ")" -type f -print0 | xargs -0 rm -f
540 fi
541 }
542 if _python_package_supporting_installation_for_multiple_python_abis; then
543 python_execute_function -q python_clean_sitedirs
544 else
545 python_clean_sitedirs
546 fi
547
548 unset -f python_clean_sitedirs
549}
550
551# ================================================================================================
270# =========== FUNCTIONS FOR PACKAGES SUPPORTING INSTALLATION FOR MULTIPLE PYTHON ABIS ============ 552# =========== FUNCTIONS FOR PACKAGES SUPPORTING INSTALLATION FOR MULTIPLE PYTHON ABIS ============
271# ================================================================================================ 553# ================================================================================================
272 554
273# @ECLASS-VARIABLE: SUPPORT_PYTHON_ABIS 555# @ECLASS-VARIABLE: SUPPORT_PYTHON_ABIS
274# @DESCRIPTION: 556# @DESCRIPTION:
279# @DESCRIPTION: 561# @DESCRIPTION:
280# Set this to export phase functions for the following ebuild phases: 562# Set this to export phase functions for the following ebuild phases:
281# src_prepare, src_configure, src_compile, src_test, src_install. 563# src_prepare, src_configure, src_compile, src_test, src_install.
282if ! has "${EAPI:-0}" 0 1; then 564if ! has "${EAPI:-0}" 0 1; then
283 python_src_prepare() { 565 python_src_prepare() {
566 _python_check_python_pkg_setup_execution
567
284 if ! _python_package_supporting_installation_for_multiple_python_abis; then 568 if ! _python_package_supporting_installation_for_multiple_python_abis; then
285 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 569 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
286 fi 570 fi
287 571
572 if [[ "$#" -ne 0 ]]; then
573 die "${FUNCNAME}() does not accept arguments"
574 fi
575
288 python_copy_sources 576 python_copy_sources
289 } 577 }
290 578
291 for python_default_function in src_configure src_compile src_test src_install; do 579 for python_default_function in src_configure src_compile src_test src_install; do
292 eval "python_${python_default_function}() { 580 eval "python_${python_default_function}() {
581 _python_check_python_pkg_setup_execution
582
293 if ! _python_package_supporting_installation_for_multiple_python_abis; then 583 if ! _python_package_supporting_installation_for_multiple_python_abis; then
294 die \"\${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs\" 584 die \"\${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs\"
295 fi 585 fi
296 586
297 python_execute_function -d -s \"\$@\" 587 python_execute_function -d -s -- \"\$@\"
298 }" 588 }"
299 done 589 done
300 unset python_default_function 590 unset python_default_function
301 591
302 if [[ -n "${PYTHON_EXPORT_PHASE_FUNCTIONS}" ]]; then 592 if [[ -n "${PYTHON_EXPORT_PHASE_FUNCTIONS}" ]]; then
303 EXPORT_FUNCTIONS src_prepare src_configure src_compile src_test src_install 593 EXPORT_FUNCTIONS src_prepare src_configure src_compile src_test src_install
304 fi 594 fi
305fi 595fi
306 596
597if has "${EAPI:-0}" 0 1 2 3; then
307unset PYTHON_ABIS 598 unset PYTHON_ABIS
599fi
308 600
309# @FUNCTION: validate_PYTHON_ABIS 601_python_calculate_PYTHON_ABIS() {
310# @DESCRIPTION:
311# Ensure that PYTHON_ABIS variable has valid value.
312# This function usually should not be directly called in ebuilds.
313validate_PYTHON_ABIS() {
314 if ! _python_package_supporting_installation_for_multiple_python_abis; then 602 if ! _python_package_supporting_installation_for_multiple_python_abis; then
315 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 603 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
316 fi 604 fi
317 605
318 _python_initial_sanity_checks 606 _python_initial_sanity_checks
319 607
320 # USE_${ABI_TYPE^^} and RESTRICT_${ABI_TYPE^^}_ABIS variables hopefully will be included in EAPI >= 5.
321 if [[ "$(declare -p PYTHON_ABIS 2> /dev/null)" != "declare -x PYTHON_ABIS="* ]] && has "${EAPI:-0}" 0 1 2 3 4; then 608 if [[ "$(declare -p PYTHON_ABIS 2> /dev/null)" != "declare -x PYTHON_ABIS="* ]] && has "${EAPI:-0}" 0 1 2 3; then
322 local PYTHON_ABI restricted_ABI support_ABI supported_PYTHON_ABIS= 609 local PYTHON_ABI restricted_ABI restricted_ABIs support_ABI supported_PYTHON_ABIS
323 PYTHON_ABI_SUPPORTED_VALUES="${_CPYTHON2_SUPPORTED_ABIS[@]} ${_CPYTHON3_SUPPORTED_ABIS[@]} ${_JYTHON_SUPPORTED_ABIS[@]}" 610
611 restricted_ABIs="${RESTRICT_PYTHON_ABIS// /$'\n'}"
324 612
325 if [[ "$(declare -p USE_PYTHON 2> /dev/null)" == "declare -x USE_PYTHON="* ]]; then 613 if [[ "$(declare -p USE_PYTHON 2> /dev/null)" == "declare -x USE_PYTHON="* ]]; then
326 local cpython_enabled="0" 614 local cpython_enabled="0"
327 615
328 if [[ -z "${USE_PYTHON}" ]]; then 616 if [[ -z "${USE_PYTHON}" ]]; then
329 die "USE_PYTHON variable is empty" 617 die "USE_PYTHON variable is empty"
330 fi 618 fi
331 619
332 for PYTHON_ABI in ${USE_PYTHON}; do 620 for PYTHON_ABI in ${USE_PYTHON}; do
333 if ! has "${PYTHON_ABI}" ${PYTHON_ABI_SUPPORTED_VALUES}; then 621 if ! has "${PYTHON_ABI}" ${_PYTHON_SUPPORTED_ABIS[@]}; then
334 die "USE_PYTHON variable contains invalid value '${PYTHON_ABI}'" 622 die "USE_PYTHON variable contains invalid value '${PYTHON_ABI}'"
335 fi 623 fi
336 624
337 if has "${PYTHON_ABI}" "${_CPYTHON2_SUPPORTED_ABIS[@]}" "${_CPYTHON3_SUPPORTED_ABIS[@]}"; then 625 if has "${PYTHON_ABI}" "${_CPYTHON2_SUPPORTED_ABIS[@]}" "${_CPYTHON3_SUPPORTED_ABIS[@]}"; then
338 cpython_enabled="1" 626 cpython_enabled="1"
339 fi 627 fi
340 628
341 support_ABI="1" 629 support_ABI="1"
342 for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do 630 while read restricted_ABI; do
343 if [[ "${PYTHON_ABI}" == ${restricted_ABI} ]]; then 631 if [[ "${PYTHON_ABI}" == ${restricted_ABI} ]]; then
344 support_ABI="0" 632 support_ABI="0"
345 break 633 break
346 fi 634 fi
347 done 635 done <<< "${restricted_ABIs}"
348 [[ "${support_ABI}" == "1" ]] && export PYTHON_ABIS+="${PYTHON_ABIS:+ }${PYTHON_ABI}" 636 [[ "${support_ABI}" == "1" ]] && export PYTHON_ABIS+="${PYTHON_ABIS:+ }${PYTHON_ABI}"
349 done 637 done
350 638
351 if [[ -z "${PYTHON_ABIS//[${IFS}]/}" ]]; then 639 if [[ -z "${PYTHON_ABIS//[${IFS}]/}" ]]; then
352 die "USE_PYTHON variable does not enable any Python ABI supported by ${CATEGORY}/${PF}" 640 die "USE_PYTHON variable does not enable any Python ABI supported by ${CATEGORY}/${PF}"
355 if [[ "${cpython_enabled}" == "0" ]]; then 643 if [[ "${cpython_enabled}" == "0" ]]; then
356 die "USE_PYTHON variable does not enable any CPython ABI" 644 die "USE_PYTHON variable does not enable any CPython ABI"
357 fi 645 fi
358 else 646 else
359 local python_version python2_version= python3_version= support_python_major_version 647 local python_version python2_version= python3_version= support_python_major_version
648
649 if ! has_version "dev-lang/python"; then
650 die "${FUNCNAME}(): 'dev-lang/python' is not installed"
651 fi
360 652
361 python_version="$("${EPREFIX}/usr/bin/python" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')" 653 python_version="$("${EPREFIX}/usr/bin/python" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')"
362 654
363 if has_version "=dev-lang/python-2*"; then 655 if has_version "=dev-lang/python-2*"; then
364 if [[ "$(readlink "${EPREFIX}/usr/bin/python2")" != "python2."* ]]; then 656 if [[ "$(readlink "${EPREFIX}/usr/bin/python2")" != "python2."* ]]; then
367 659
368 python2_version="$("${EPREFIX}/usr/bin/python2" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')" 660 python2_version="$("${EPREFIX}/usr/bin/python2" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')"
369 661
370 for PYTHON_ABI in "${_CPYTHON2_SUPPORTED_ABIS[@]}"; do 662 for PYTHON_ABI in "${_CPYTHON2_SUPPORTED_ABIS[@]}"; do
371 support_python_major_version="1" 663 support_python_major_version="1"
372 for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do 664 while read restricted_ABI; do
373 if [[ "${PYTHON_ABI}" == ${restricted_ABI} ]]; then 665 if [[ "${PYTHON_ABI}" == ${restricted_ABI} ]]; then
374 support_python_major_version="0" 666 support_python_major_version="0"
375 fi 667 fi
376 done 668 done <<< "${restricted_ABIs}"
377 [[ "${support_python_major_version}" == "1" ]] && break 669 [[ "${support_python_major_version}" == "1" ]] && break
378 done 670 done
379 if [[ "${support_python_major_version}" == "1" ]]; then 671 if [[ "${support_python_major_version}" == "1" ]]; then
380 for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do 672 while read restricted_ABI; do
381 if [[ "${python2_version}" == ${restricted_ABI} ]]; then 673 if [[ "${python2_version}" == ${restricted_ABI} ]]; then
382 die "Active version of Python 2 is not supported by ${CATEGORY}/${PF}" 674 die "Active version of Python 2 is not supported by ${CATEGORY}/${PF}"
383 fi 675 fi
384 done 676 done <<< "${restricted_ABIs}"
385 else 677 else
386 python2_version="" 678 python2_version=""
387 fi 679 fi
388 fi 680 fi
389 681
394 686
395 python3_version="$("${EPREFIX}/usr/bin/python3" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')" 687 python3_version="$("${EPREFIX}/usr/bin/python3" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')"
396 688
397 for PYTHON_ABI in "${_CPYTHON3_SUPPORTED_ABIS[@]}"; do 689 for PYTHON_ABI in "${_CPYTHON3_SUPPORTED_ABIS[@]}"; do
398 support_python_major_version="1" 690 support_python_major_version="1"
399 for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do 691 while read restricted_ABI; do
400 if [[ "${PYTHON_ABI}" == ${restricted_ABI} ]]; then 692 if [[ "${PYTHON_ABI}" == ${restricted_ABI} ]]; then
401 support_python_major_version="0" 693 support_python_major_version="0"
402 fi 694 fi
403 done 695 done <<< "${restricted_ABIs}"
404 [[ "${support_python_major_version}" == "1" ]] && break 696 [[ "${support_python_major_version}" == "1" ]] && break
405 done 697 done
406 if [[ "${support_python_major_version}" == "1" ]]; then 698 if [[ "${support_python_major_version}" == "1" ]]; then
407 for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do 699 while read restricted_ABI; do
408 if [[ "${python3_version}" == ${restricted_ABI} ]]; then 700 if [[ "${python3_version}" == ${restricted_ABI} ]]; then
409 die "Active version of Python 3 is not supported by ${CATEGORY}/${PF}" 701 die "Active version of Python 3 is not supported by ${CATEGORY}/${PF}"
410 fi 702 fi
411 done 703 done <<< "${restricted_ABIs}"
412 else 704 else
413 python3_version="" 705 python3_version=""
414 fi 706 fi
415 fi 707 fi
416 708
432 fi 724 fi
433 725
434 _python_final_sanity_checks 726 _python_final_sanity_checks
435} 727}
436 728
729_python_prepare_flags() {
730 local array=() deleted_flag element flags new_value old_flag old_value operator pattern prefix variable
731
732 for variable in CPPFLAGS CFLAGS CXXFLAGS LDFLAGS; do
733 eval "_PYTHON_SAVED_${variable}=\"\${!variable}\""
734 for prefix in PYTHON_USER_ PYTHON_; do
735 if [[ "$(declare -p ${prefix}${variable} 2> /dev/null)" == "declare -a ${prefix}${variable}="* ]]; then
736 eval "array=(\"\${${prefix}${variable}[@]}\")"
737 for element in "${array[@]}"; do
738 if [[ "${element}" =~ ^([[:alnum:]]|\.|-|\*|\[|\])+\ (\+|-)\ .+ ]]; then
739 pattern="${element%% *}"
740 element="${element#* }"
741 operator="${element%% *}"
742 flags="${element#* }"
743 if [[ "${PYTHON_ABI}" == ${pattern} ]]; then
744 if [[ "${operator}" == "+" ]]; then
745 eval "export ${variable}+=\"\${variable:+ }${flags}\""
746 elif [[ "${operator}" == "-" ]]; then
747 flags="${flags// /$'\n'}"
748 old_value="${!variable// /$'\n'}"
749 new_value=""
750 while read old_flag; do
751 while read deleted_flag; do
752 if [[ "${old_flag}" == ${deleted_flag} ]]; then
753 continue 2
754 fi
755 done <<< "${flags}"
756 new_value+="${new_value:+ }${old_flag}"
757 done <<< "${old_value}"
758 eval "export ${variable}=\"\${new_value}\""
759 fi
760 fi
761 else
762 die "Element '${element}' of ${prefix}${variable} array has invalid syntax"
763 fi
764 done
765 elif [[ -n "$(declare -p ${prefix}${variable} 2> /dev/null)" ]]; then
766 die "${prefix}${variable} should be indexed array"
767 fi
768 done
769 done
770}
771
772_python_restore_flags() {
773 local variable
774
775 for variable in CPPFLAGS CFLAGS CXXFLAGS LDFLAGS; do
776 eval "${variable}=\"\${_PYTHON_SAVED_${variable}}\""
777 unset _PYTHON_SAVED_${variable}
778 done
779}
780
437# @FUNCTION: python_execute_function 781# @FUNCTION: python_execute_function
438# @USAGE: [--action-message message] [-d|--default-function] [--failure-message message] [-f|--final-ABI] [--nonfatal] [-q|--quiet] [-s|--separate-build-dirs] [--source-dir source_directory] [--] <function> [arguments] 782# @USAGE: [--action-message message] [-d|--default-function] [--failure-message message] [-f|--final-ABI] [--nonfatal] [-q|--quiet] [-s|--separate-build-dirs] [--source-dir source_directory] [--] <function> [arguments]
439# @DESCRIPTION: 783# @DESCRIPTION:
440# Execute specified function for each value of PYTHON_ABIS, optionally passing additional 784# Execute specified function for each value of PYTHON_ABIS, optionally passing additional
441# arguments. The specified function can use PYTHON_ABI and BUILDDIR variables. 785# arguments. The specified function can use PYTHON_ABI and BUILDDIR variables.
442python_execute_function() { 786python_execute_function() {
787 _python_check_python_pkg_setup_execution
788
443 if ! _python_package_supporting_installation_for_multiple_python_abis; then 789 if ! _python_package_supporting_installation_for_multiple_python_abis; then
444 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 790 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
445 fi 791 fi
446 792
447 _python_set_color_variables 793 _python_set_color_variables
448 794
449 local action action_message action_message_template= default_function="0" failure_message failure_message_template= final_ABI="0" function i iterated_PYTHON_ABIS nonfatal="0" previous_directory previous_directory_stack previous_directory_stack_length PYTHON_ABI quiet="0" separate_build_dirs="0" source_dir= 795 local action action_message action_message_template= default_function="0" failure_message failure_message_template= final_ABI="0" function iterated_PYTHON_ABIS nonfatal="0" previous_directory previous_directory_stack previous_directory_stack_length PYTHON_ABI quiet="0" return_code separate_build_dirs="0" source_dir=
450 796
451 while (($#)); do 797 while (($#)); do
452 case "$1" in 798 case "$1" in
453 --action-message) 799 --action-message)
454 action_message_template="$2" 800 action_message_template="$2"
541 fi 887 fi
542 function="python_default_function" 888 function="python_default_function"
543 fi 889 fi
544 890
545 # Ensure that python_execute_function() cannot be directly or indirectly called by python_execute_function(). 891 # Ensure that python_execute_function() cannot be directly or indirectly called by python_execute_function().
546 for ((i = 1; i < "${#FUNCNAME[@]}"; i++)); do 892 if _python_abi-specific_local_scope; then
547 if [[ "${FUNCNAME[${i}]}" == "${FUNCNAME}" ]]; then
548 die "${FUNCNAME}(): Invalid call stack" 893 die "${FUNCNAME}(): Invalid call stack"
549 fi 894 fi
550 done
551 895
552 if [[ "${quiet}" == "0" ]]; then 896 if [[ "${quiet}" == "0" ]]; then
553 [[ "${EBUILD_PHASE}" == "setup" ]] && action="Setting up" 897 [[ "${EBUILD_PHASE}" == "setup" ]] && action="Setting up"
554 [[ "${EBUILD_PHASE}" == "unpack" ]] && action="Unpacking" 898 [[ "${EBUILD_PHASE}" == "unpack" ]] && action="Unpacking"
555 [[ "${EBUILD_PHASE}" == "prepare" ]] && action="Preparation" 899 [[ "${EBUILD_PHASE}" == "prepare" ]] && action="Preparation"
561 [[ "${EBUILD_PHASE}" == "postinst" ]] && action="Postinstallation" 905 [[ "${EBUILD_PHASE}" == "postinst" ]] && action="Postinstallation"
562 [[ "${EBUILD_PHASE}" == "prerm" ]] && action="Preuninstallation" 906 [[ "${EBUILD_PHASE}" == "prerm" ]] && action="Preuninstallation"
563 [[ "${EBUILD_PHASE}" == "postrm" ]] && action="Postuninstallation" 907 [[ "${EBUILD_PHASE}" == "postrm" ]] && action="Postuninstallation"
564 fi 908 fi
565 909
566 validate_PYTHON_ABIS 910 _python_calculate_PYTHON_ABIS
567 if [[ "${final_ABI}" == "1" ]]; then 911 if [[ "${final_ABI}" == "1" ]]; then
568 iterated_PYTHON_ABIS="$(PYTHON -f --ABI)" 912 iterated_PYTHON_ABIS="$(PYTHON -f --ABI)"
569 else 913 else
570 iterated_PYTHON_ABIS="${PYTHON_ABIS}" 914 iterated_PYTHON_ABIS="${PYTHON_ABIS}"
571 fi 915 fi
572 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do 916 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
917 _python_prepare_flags
918
573 if [[ "${quiet}" == "0" ]]; then 919 if [[ "${quiet}" == "0" ]]; then
574 if [[ -n "${action_message_template}" ]]; then 920 if [[ -n "${action_message_template}" ]]; then
575 action_message="$(eval echo -n "${action_message_template}")" 921 eval "action_message=\"${action_message_template}\""
576 else 922 else
577 action_message="${action} of ${CATEGORY}/${PF} with $(python_get_implementation) $(python_get_version)..." 923 action_message="${action} of ${CATEGORY}/${PF} with $(python_get_implementation) $(python_get_version)..."
578 fi 924 fi
579 echo " ${_GREEN}*${_NORMAL} ${_BLUE}${action_message}${_NORMAL}" 925 echo " ${_GREEN}*${_NORMAL} ${_BLUE}${action_message}${_NORMAL}"
580 fi 926 fi
598 EPYTHON="$(PYTHON)" nonfatal "${function}" "$@" 944 EPYTHON="$(PYTHON)" nonfatal "${function}" "$@"
599 else 945 else
600 EPYTHON="$(PYTHON)" "${function}" "$@" 946 EPYTHON="$(PYTHON)" "${function}" "$@"
601 fi 947 fi
602 948
603 if [[ "$?" != "0" ]]; then 949 return_code="$?"
950
951 _python_restore_flags
952
953 if [[ "${return_code}" -ne 0 ]]; then
604 if [[ -n "${failure_message_template}" ]]; then 954 if [[ -n "${failure_message_template}" ]]; then
605 failure_message="$(eval echo -n "${failure_message_template}")" 955 eval "failure_message=\"${failure_message_template}\""
606 else 956 else
607 failure_message="${action} failed with $(python_get_implementation) $(python_get_version) in ${function}() function" 957 failure_message="${action} failed with $(python_get_implementation) $(python_get_version) in ${function}() function"
608 fi 958 fi
609 959
610 if [[ "${nonfatal}" == "1" ]]; then 960 if [[ "${nonfatal}" == "1" ]]; then
611 if [[ "${quiet}" == "0" ]]; then 961 if [[ "${quiet}" == "0" ]]; then
612 ewarn "${_RED}${failure_message}${_NORMAL}" 962 ewarn "${failure_message}"
613 fi 963 fi
614 elif [[ "${final_ABI}" == "0" ]] && has "${PYTHON_ABI}" ${FAILURE_TOLERANT_PYTHON_ABIS}; then 964 elif [[ "${final_ABI}" == "0" ]] && has "${PYTHON_ABI}" ${FAILURE_TOLERANT_PYTHON_ABIS}; then
615 if [[ "${EBUILD_PHASE}" != "test" ]] || ! has test-fail-continue ${FEATURES}; then 965 if [[ "${EBUILD_PHASE}" != "test" ]] || ! has test-fail-continue ${FEATURES}; then
616 local enabled_PYTHON_ABIS= other_PYTHON_ABI 966 local enabled_PYTHON_ABIS= other_PYTHON_ABI
617 for other_PYTHON_ABI in ${PYTHON_ABIS}; do 967 for other_PYTHON_ABI in ${PYTHON_ABIS}; do
618 [[ "${other_PYTHON_ABI}" != "${PYTHON_ABI}" ]] && enabled_PYTHON_ABIS+="${enabled_PYTHON_ABIS:+ }${other_PYTHON_ABI}" 968 [[ "${other_PYTHON_ABI}" != "${PYTHON_ABI}" ]] && enabled_PYTHON_ABIS+="${enabled_PYTHON_ABIS:+ }${other_PYTHON_ABI}"
619 done 969 done
620 export PYTHON_ABIS="${enabled_PYTHON_ABIS}" 970 export PYTHON_ABIS="${enabled_PYTHON_ABIS}"
621 fi 971 fi
622 if [[ "${quiet}" == "0" ]]; then 972 if [[ "${quiet}" == "0" ]]; then
623 ewarn "${_RED}${failure_message}${_NORMAL}" 973 ewarn "${failure_message}"
624 fi 974 fi
625 if [[ -z "${PYTHON_ABIS}" ]]; then 975 if [[ -z "${PYTHON_ABIS}" ]]; then
626 die "${function}() function failed with all enabled Python ABIs" 976 die "${function}() function failed with all enabled Python ABIs"
627 fi 977 fi
628 else 978 else
665# @FUNCTION: python_copy_sources 1015# @FUNCTION: python_copy_sources
666# @USAGE: <directory="${S}"> [directory] 1016# @USAGE: <directory="${S}"> [directory]
667# @DESCRIPTION: 1017# @DESCRIPTION:
668# Copy unpacked sources of current package to separate build directory for each Python ABI. 1018# Copy unpacked sources of current package to separate build directory for each Python ABI.
669python_copy_sources() { 1019python_copy_sources() {
1020 _python_check_python_pkg_setup_execution
1021
670 if ! _python_package_supporting_installation_for_multiple_python_abis; then 1022 if ! _python_package_supporting_installation_for_multiple_python_abis; then
671 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 1023 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
672 fi 1024 fi
673 1025
674 local dir dirs=() PYTHON_ABI 1026 local dir dirs=() PYTHON_ABI
675 1027
676 if [[ "$#" -eq 0 ]]; then 1028 if [[ "$#" -eq 0 ]]; then
677 if [[ "${WORKDIR}" == "${S}" ]]; then 1029 if [[ "${WORKDIR}" == "${S}" ]]; then
678 die "${FUNCNAME}() cannot be used" 1030 die "${FUNCNAME}() cannot be used with current value of S variable"
679 fi 1031 fi
680 dirs=("${S%/}") 1032 dirs=("${S%/}")
681 else 1033 else
682 dirs=("$@") 1034 dirs=("$@")
683 fi 1035 fi
684 1036
685 validate_PYTHON_ABIS 1037 _python_calculate_PYTHON_ABIS
686 for PYTHON_ABI in ${PYTHON_ABIS}; do 1038 for PYTHON_ABI in ${PYTHON_ABIS}; do
687 for dir in "${dirs[@]}"; do 1039 for dir in "${dirs[@]}"; do
688 cp -pr "${dir}" "${dir}-${PYTHON_ABI}" > /dev/null || die "Copying of sources failed" 1040 cp -pr "${dir}" "${dir}-${PYTHON_ABI}" > /dev/null || die "Copying of sources failed"
689 done 1041 done
690 done 1042 done
695# @DESCRIPTION: 1047# @DESCRIPTION:
696# Generate wrapper scripts. Existing files are overwritten only with --force option. 1048# Generate wrapper scripts. Existing files are overwritten only with --force option.
697# If --respect-EPYTHON option is specified, then generated wrapper scripts will 1049# If --respect-EPYTHON option is specified, then generated wrapper scripts will
698# respect EPYTHON variable at run time. 1050# respect EPYTHON variable at run time.
699python_generate_wrapper_scripts() { 1051python_generate_wrapper_scripts() {
1052 _python_check_python_pkg_setup_execution
1053
700 if ! _python_package_supporting_installation_for_multiple_python_abis; then 1054 if ! _python_package_supporting_installation_for_multiple_python_abis; then
701 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 1055 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
702 fi 1056 fi
703 1057
704 _python_initialize_prefix_variables 1058 _python_initialize_prefix_variables
732 1086
733 if [[ "$#" -eq 0 ]]; then 1087 if [[ "$#" -eq 0 ]]; then
734 die "${FUNCNAME}(): Missing arguments" 1088 die "${FUNCNAME}(): Missing arguments"
735 fi 1089 fi
736 1090
737 validate_PYTHON_ABIS 1091 _python_calculate_PYTHON_ABIS
738 for PYTHON_ABI in "${_CPYTHON2_SUPPORTED_ABIS[@]}"; do 1092 for PYTHON_ABI in "${_CPYTHON2_SUPPORTED_ABIS[@]}"; do
739 if has "${PYTHON_ABI}" ${PYTHON_ABIS}; then 1093 if has "${PYTHON_ABI}" ${PYTHON_ABIS}; then
740 python2_enabled="1" 1094 python2_enabled="1"
741 fi 1095 fi
742 done 1096 done
846 fi 1200 fi
847 cat << EOF >> "${file}" 1201 cat << EOF >> "${file}"
848 1202
849wrapper_script_path = os.path.realpath(sys.argv[0]) 1203wrapper_script_path = os.path.realpath(sys.argv[0])
850target_executable_path = "%s-%s" % (wrapper_script_path, PYTHON_ABI) 1204target_executable_path = "%s-%s" % (wrapper_script_path, PYTHON_ABI)
1205os.environ["GENTOO_PYTHON_PROCESS_NAME"] = os.path.basename(sys.argv[0])
851os.environ["GENTOO_PYTHON_WRAPPER_SCRIPT_PATH"] = sys.argv[0] 1206os.environ["GENTOO_PYTHON_WRAPPER_SCRIPT_PATH"] = sys.argv[0]
852os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH"] = target_executable_path 1207os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH"] = target_executable_path
853if not os.path.exists(target_executable_path): 1208if not os.path.exists(target_executable_path):
854 sys.stderr.write("'%s' does not exist\n" % target_executable_path) 1209 sys.stderr.write("'%s' does not exist\n" % target_executable_path)
855 sys.exit(1) 1210 sys.exit(1)
897 1252
898# ================================================================================================ 1253# ================================================================================================
899# ========= FUNCTIONS FOR PACKAGES NOT SUPPORTING INSTALLATION FOR MULTIPLE PYTHON ABIS ========== 1254# ========= FUNCTIONS FOR PACKAGES NOT SUPPORTING INSTALLATION FOR MULTIPLE PYTHON ABIS ==========
900# ================================================================================================ 1255# ================================================================================================
901 1256
1257unset EPYTHON PYTHON_ABI
1258
902# @FUNCTION: python_set_active_version 1259# @FUNCTION: python_set_active_version
903# @USAGE: <CPython_ABI|2|3> 1260# @USAGE: <CPython_ABI|2|3>
904# @DESCRIPTION: 1261# @DESCRIPTION:
905# Set specified version of CPython as active version of Python. 1262# Set specified version of CPython as active version of Python.
1263#
1264# This function can be used only in pkg_setup() phase.
906python_set_active_version() { 1265python_set_active_version() {
1266 # Check if phase is pkg_setup().
1267 [[ "${EBUILD_PHASE}" != "setup" ]] && die "${FUNCNAME}() can be used only in pkg_setup() phase"
1268
907 if _python_package_supporting_installation_for_multiple_python_abis; then 1269 if _python_package_supporting_installation_for_multiple_python_abis; then
908 die "${FUNCNAME}() cannot be used in ebuilds of packages supporting installation for multiple Python ABIs" 1270 die "${FUNCNAME}() cannot be used in ebuilds of packages supporting installation for multiple Python ABIs"
909 fi 1271 fi
910 1272
911 if [[ "$#" -ne 1 ]]; then 1273 if [[ "$#" -ne 1 ]]; then
912 die "${FUNCNAME}() requires 1 argument" 1274 die "${FUNCNAME}() requires 1 argument"
913 fi 1275 fi
914 1276
915 _python_initial_sanity_checks 1277 _python_initial_sanity_checks
916 1278
1279 if [[ -z "${PYTHON_ABI}" ]]; then
917 if [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then 1280 if [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then
918 if ! _python_implementation && ! has_version "dev-lang/python:$1"; then 1281 if ! _python_implementation && ! has_version "dev-lang/python:$1"; then
919 die "${FUNCNAME}(): 'dev-lang/python:$1' is not installed" 1282 die "${FUNCNAME}(): 'dev-lang/python:$1' is not installed"
920 fi 1283 fi
921 export EPYTHON="$(PYTHON "$1")" 1284 export EPYTHON="$(PYTHON "$1")"
922 elif [[ "$1" == "2" ]]; then 1285 elif [[ "$1" == "2" ]]; then
923 if ! _python_implementation && ! has_version "=dev-lang/python-2*"; then 1286 if ! _python_implementation && ! has_version "=dev-lang/python-2*"; then
924 die "${FUNCNAME}(): '=dev-lang/python-2*' is not installed" 1287 die "${FUNCNAME}(): '=dev-lang/python-2*' is not installed"
925 fi 1288 fi
926 export EPYTHON="$(PYTHON -2)" 1289 export EPYTHON="$(PYTHON -2)"
927 elif [[ "$1" == "3" ]]; then 1290 elif [[ "$1" == "3" ]]; then
928 if ! _python_implementation && ! has_version "=dev-lang/python-3*"; then 1291 if ! _python_implementation && ! has_version "=dev-lang/python-3*"; then
929 die "${FUNCNAME}(): '=dev-lang/python-3*' is not installed" 1292 die "${FUNCNAME}(): '=dev-lang/python-3*' is not installed"
930 fi 1293 fi
931 export EPYTHON="$(PYTHON -3)" 1294 export EPYTHON="$(PYTHON -3)"
932 else 1295 else
933 die "${FUNCNAME}(): Unrecognized argument '$1'" 1296 die "${FUNCNAME}(): Unrecognized argument '$1'"
934 fi 1297 fi
935 1298
936 # PYTHON_ABI variable is intended to be used only in ebuilds/eclasses, 1299 # PYTHON_ABI variable is intended to be used only in ebuilds/eclasses,
937 # so it does not need to be exported to subprocesses. 1300 # so it does not need to be exported to subprocesses.
938 PYTHON_ABI="${EPYTHON#python}" 1301 PYTHON_ABI="${EPYTHON#python}"
939 PYTHON_ABI="${PYTHON_ABI%%-*}" 1302 PYTHON_ABI="${PYTHON_ABI%%-*}"
1303 fi
940 1304
941 _python_final_sanity_checks 1305 _python_final_sanity_checks
942 1306
943 # python-updater checks PYTHON_REQUESTED_ACTIVE_VERSION variable. 1307 # python-updater checks PYTHON_REQUESTED_ACTIVE_VERSION variable.
944 PYTHON_REQUESTED_ACTIVE_VERSION="$1" 1308 PYTHON_REQUESTED_ACTIVE_VERSION="$1"
946 1310
947# @FUNCTION: python_need_rebuild 1311# @FUNCTION: python_need_rebuild
948# @DESCRIPTION: Mark current package for rebuilding by python-updater after 1312# @DESCRIPTION: Mark current package for rebuilding by python-updater after
949# switching of active version of Python. 1313# switching of active version of Python.
950python_need_rebuild() { 1314python_need_rebuild() {
1315 _python_check_python_pkg_setup_execution
1316
951 if _python_package_supporting_installation_for_multiple_python_abis; then 1317 if _python_package_supporting_installation_for_multiple_python_abis; then
952 die "${FUNCNAME}() cannot be used in ebuilds of packages supporting installation for multiple Python ABIs" 1318 die "${FUNCNAME}() cannot be used in ebuilds of packages supporting installation for multiple Python ABIs"
1319 fi
1320
1321 if [[ "$#" -ne 0 ]]; then
1322 die "${FUNCNAME}() does not accept arguments"
953 fi 1323 fi
954 1324
955 export PYTHON_NEED_REBUILD="$(PYTHON --ABI)" 1325 export PYTHON_NEED_REBUILD="$(PYTHON --ABI)"
956} 1326}
957 1327
991# If --ABI option is specified, then only specified Python ABI is printed instead of 1361# If --ABI option is specified, then only specified Python ABI is printed instead of
992# filename of Python interpreter. 1362# filename of Python interpreter.
993# If --absolute-path option is specified, then absolute path to Python interpreter is printed. 1363# If --absolute-path option is specified, then absolute path to Python interpreter is printed.
994# --ABI and --absolute-path options cannot be specified simultaneously. 1364# --ABI and --absolute-path options cannot be specified simultaneously.
995PYTHON() { 1365PYTHON() {
1366 _python_check_python_pkg_setup_execution
1367
996 local ABI_output="0" absolute_path_output="0" final_ABI="0" PYTHON_ABI="${PYTHON_ABI}" python_interpreter python2="0" python3="0" 1368 local ABI_output="0" absolute_path_output="0" final_ABI="0" PYTHON_ABI="${PYTHON_ABI}" python_interpreter python2="0" python3="0"
997 1369
998 while (($#)); do 1370 while (($#)); do
999 case "$1" in 1371 case "$1" in
1000 -2) 1372 -2)
1025 esac 1397 esac
1026 shift 1398 shift
1027 done 1399 done
1028 1400
1029 if [[ "${ABI_output}" == "1" && "${absolute_path_output}" == "1" ]]; then 1401 if [[ "${ABI_output}" == "1" && "${absolute_path_output}" == "1" ]]; then
1030 die "${FUNCNAME}(): '--ABI and '--absolute-path' options cannot be specified simultaneously" 1402 die "${FUNCNAME}(): '--ABI' and '--absolute-path' options cannot be specified simultaneously"
1031 fi 1403 fi
1032 1404
1033 if [[ "$((${python2} + ${python3} + ${final_ABI}))" -gt 1 ]]; then 1405 if [[ "$((${python2} + ${python3} + ${final_ABI}))" -gt 1 ]]; then
1034 die "${FUNCNAME}(): '-2', '-3' or '--final-ABI' options cannot be specified simultaneously" 1406 die "${FUNCNAME}(): '-2', '-3' or '--final-ABI' options cannot be specified simultaneously"
1035 fi 1407 fi
1037 if [[ "$#" -eq 0 ]]; then 1409 if [[ "$#" -eq 0 ]]; then
1038 if [[ "${final_ABI}" == "1" ]]; then 1410 if [[ "${final_ABI}" == "1" ]]; then
1039 if ! _python_package_supporting_installation_for_multiple_python_abis; then 1411 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1040 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 1412 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1041 fi 1413 fi
1042 validate_PYTHON_ABIS 1414 _python_calculate_PYTHON_ABIS
1043 PYTHON_ABI="${PYTHON_ABIS##* }" 1415 PYTHON_ABI="${PYTHON_ABIS##* }"
1044 elif [[ "${python2}" == "1" ]]; then 1416 elif [[ "${python2}" == "1" ]]; then
1045 PYTHON_ABI="$(eselect python show --python2 --ABI)" 1417 PYTHON_ABI="$(eselect python show --python2 --ABI)"
1046 if [[ -z "${PYTHON_ABI}" ]]; then 1418 if [[ -z "${PYTHON_ABI}" ]]; then
1047 die "${FUNCNAME}(): Active Python 2 interpreter not set" 1419 die "${FUNCNAME}(): Active version of Python 2 not set"
1048 elif [[ "${PYTHON_ABI}" != "2."* ]]; then 1420 elif [[ "${PYTHON_ABI}" != "2."* ]]; then
1049 die "${FUNCNAME}(): Internal error in \`eselect python show --python2\`" 1421 die "${FUNCNAME}(): Internal error in \`eselect python show --python2\`"
1050 fi 1422 fi
1051 elif [[ "${python3}" == "1" ]]; then 1423 elif [[ "${python3}" == "1" ]]; then
1052 PYTHON_ABI="$(eselect python show --python3 --ABI)" 1424 PYTHON_ABI="$(eselect python show --python3 --ABI)"
1053 if [[ -z "${PYTHON_ABI}" ]]; then 1425 if [[ -z "${PYTHON_ABI}" ]]; then
1054 die "${FUNCNAME}(): Active Python 3 interpreter not set" 1426 die "${FUNCNAME}(): Active version of Python 3 not set"
1055 elif [[ "${PYTHON_ABI}" != "3."* ]]; then 1427 elif [[ "${PYTHON_ABI}" != "3."* ]]; then
1056 die "${FUNCNAME}(): Internal error in \`eselect python show --python3\`" 1428 die "${FUNCNAME}(): Internal error in \`eselect python show --python3\`"
1057 fi 1429 fi
1058 elif ! _python_package_supporting_installation_for_multiple_python_abis; then 1430 elif _python_package_supporting_installation_for_multiple_python_abis; then
1431 if ! _python_abi-specific_local_scope; then
1432 die "${FUNCNAME}() should be used in ABI-specific local scope"
1433 fi
1434 else
1059 PYTHON_ABI="$("${EPREFIX}/usr/bin/python" -c "${_PYTHON_ABI_EXTRACTION_COMMAND}")" 1435 PYTHON_ABI="$("${EPREFIX}/usr/bin/python" -c "${_PYTHON_ABI_EXTRACTION_COMMAND}")"
1060 elif [[ -z "${PYTHON_ABI}" ]]; then 1436 if [[ -z "${PYTHON_ABI}" ]]; then
1061 die "${FUNCNAME}(): Invalid usage: ${FUNCNAME}() should be used in ABI-specific local scope" 1437 die "${FUNCNAME}(): Failure of extraction of locally active version of Python"
1438 fi
1062 fi 1439 fi
1063 elif [[ "$#" -eq 1 ]]; then 1440 elif [[ "$#" -eq 1 ]]; then
1064 if [[ "${final_ABI}" == "1" ]]; then 1441 if [[ "${final_ABI}" == "1" ]]; then
1065 die "${FUNCNAME}(): '--final-ABI' option and Python ABI cannot be specified simultaneously" 1442 die "${FUNCNAME}(): '--final-ABI' option and Python ABI cannot be specified simultaneously"
1066 fi 1443 fi
1101# @USAGE: [-f|--final-ABI] 1478# @USAGE: [-f|--final-ABI]
1102# @DESCRIPTION: 1479# @DESCRIPTION:
1103# Print name of Python implementation. 1480# Print name of Python implementation.
1104# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 1481# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1105python_get_implementation() { 1482python_get_implementation() {
1483 _python_check_python_pkg_setup_execution
1484
1106 local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}" 1485 local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}"
1107 1486
1108 while (($#)); do 1487 while (($#)); do
1109 case "$1" in 1488 case "$1" in
1110 -f|--final-ABI) 1489 -f|--final-ABI)
1123 if [[ "${final_ABI}" == "1" ]]; then 1502 if [[ "${final_ABI}" == "1" ]]; then
1124 if ! _python_package_supporting_installation_for_multiple_python_abis; then 1503 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1125 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 1504 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1126 fi 1505 fi
1127 PYTHON_ABI="$(PYTHON -f --ABI)" 1506 PYTHON_ABI="$(PYTHON -f --ABI)"
1128 elif [[ -z "${PYTHON_ABI}" ]]; then 1507 else
1508 if _python_package_supporting_installation_for_multiple_python_abis; then
1509 if ! _python_abi-specific_local_scope; then
1510 die "${FUNCNAME}() should be used in ABI-specific local scope"
1511 fi
1512 else
1129 PYTHON_ABI="$(PYTHON --ABI)" 1513 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
1514 fi
1130 fi 1515 fi
1131 1516
1132 echo "$(_python_get_implementation "${PYTHON_ABI}")" 1517 echo "$(_python_get_implementation "${PYTHON_ABI}")"
1133} 1518}
1134 1519
1136# @USAGE: [-f|--final-ABI] 1521# @USAGE: [-f|--final-ABI]
1137# @DESCRIPTION: 1522# @DESCRIPTION:
1138# Print category, name and slot of package providing Python implementation. 1523# Print category, name and slot of package providing Python implementation.
1139# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 1524# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1140python_get_implementational_package() { 1525python_get_implementational_package() {
1526 _python_check_python_pkg_setup_execution
1527
1141 local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}" 1528 local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}"
1142 1529
1143 while (($#)); do 1530 while (($#)); do
1144 case "$1" in 1531 case "$1" in
1145 -f|--final-ABI) 1532 -f|--final-ABI)
1158 if [[ "${final_ABI}" == "1" ]]; then 1545 if [[ "${final_ABI}" == "1" ]]; then
1159 if ! _python_package_supporting_installation_for_multiple_python_abis; then 1546 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1160 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 1547 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1161 fi 1548 fi
1162 PYTHON_ABI="$(PYTHON -f --ABI)" 1549 PYTHON_ABI="$(PYTHON -f --ABI)"
1163 elif [[ -z "${PYTHON_ABI}" ]]; then 1550 else
1551 if _python_package_supporting_installation_for_multiple_python_abis; then
1552 if ! _python_abi-specific_local_scope; then
1553 die "${FUNCNAME}() should be used in ABI-specific local scope"
1554 fi
1555 else
1164 PYTHON_ABI="$(PYTHON --ABI)" 1556 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
1165 fi 1557 fi
1558 fi
1166 1559
1560 if [[ "${EAPI:-0}" == "0" ]]; then
1167 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then 1561 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1168 echo "dev-lang/python:${PYTHON_ABI}" 1562 echo "=dev-lang/python-${PYTHON_ABI}*"
1169 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then 1563 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1564 echo "=dev-java/jython-${PYTHON_ABI%-jython}*"
1565 fi
1566 else
1567 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1568 echo "dev-lang/python:${PYTHON_ABI}"
1569 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1170 echo "dev-java/jython:${PYTHON_ABI%-jython}" 1570 echo "dev-java/jython:${PYTHON_ABI%-jython}"
1571 fi
1171 fi 1572 fi
1172} 1573}
1173 1574
1174# @FUNCTION: python_get_includedir 1575# @FUNCTION: python_get_includedir
1175# @USAGE: [-f|--final-ABI] 1576# @USAGE: [-b|--base-path] [-f|--final-ABI]
1176# @DESCRIPTION: 1577# @DESCRIPTION:
1177# Print path to Python include directory. 1578# Print path to Python include directory.
1579# If --base-path option is specified, then path not prefixed with "/" is printed.
1178# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 1580# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1179python_get_includedir() { 1581python_get_includedir() {
1582 _python_check_python_pkg_setup_execution
1583
1180 local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}" 1584 local base_path="0" final_ABI="0" prefix PYTHON_ABI="${PYTHON_ABI}"
1181 1585
1182 while (($#)); do 1586 while (($#)); do
1183 case "$1" in 1587 case "$1" in
1588 -b|--base-path)
1589 base_path="1"
1590 ;;
1184 -f|--final-ABI) 1591 -f|--final-ABI)
1185 final_ABI="1" 1592 final_ABI="1"
1186 ;; 1593 ;;
1187 -*) 1594 -*)
1188 die "${FUNCNAME}(): Unrecognized option '$1'" 1595 die "${FUNCNAME}(): Unrecognized option '$1'"
1191 die "${FUNCNAME}(): Invalid usage" 1598 die "${FUNCNAME}(): Invalid usage"
1192 ;; 1599 ;;
1193 esac 1600 esac
1194 shift 1601 shift
1195 done 1602 done
1603
1604 if [[ "${base_path}" == "0" ]]; then
1605 prefix="/"
1606 fi
1196 1607
1197 if [[ "${final_ABI}" == "1" ]]; then 1608 if [[ "${final_ABI}" == "1" ]]; then
1198 if ! _python_package_supporting_installation_for_multiple_python_abis; then 1609 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1199 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 1610 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1200 fi 1611 fi
1201 PYTHON_ABI="$(PYTHON -f --ABI)" 1612 PYTHON_ABI="$(PYTHON -f --ABI)"
1202 elif [[ -z "${PYTHON_ABI}" ]]; then 1613 else
1614 if _python_package_supporting_installation_for_multiple_python_abis; then
1615 if ! _python_abi-specific_local_scope; then
1616 die "${FUNCNAME}() should be used in ABI-specific local scope"
1617 fi
1618 else
1203 PYTHON_ABI="$(PYTHON --ABI)" 1619 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
1620 fi
1204 fi 1621 fi
1205 1622
1206 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then 1623 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1207 echo "/usr/include/python${PYTHON_ABI}" 1624 echo "${prefix}usr/include/python${PYTHON_ABI}"
1208 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then 1625 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1209 echo "/usr/share/jython-${PYTHON_ABI%-jython}/Include" 1626 echo "${prefix}usr/share/jython-${PYTHON_ABI%-jython}/Include"
1210 fi 1627 fi
1211} 1628}
1212 1629
1213# @FUNCTION: python_get_libdir 1630# @FUNCTION: python_get_libdir
1214# @USAGE: [-f|--final-ABI] 1631# @USAGE: [-b|--base-path] [-f|--final-ABI]
1215# @DESCRIPTION: 1632# @DESCRIPTION:
1216# Print path to Python library directory. 1633# Print path to Python library directory.
1634# If --base-path option is specified, then path not prefixed with "/" is printed.
1217# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 1635# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1218python_get_libdir() { 1636python_get_libdir() {
1637 _python_check_python_pkg_setup_execution
1638
1219 local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}" 1639 local base_path="0" final_ABI="0" prefix PYTHON_ABI="${PYTHON_ABI}"
1220 1640
1221 while (($#)); do 1641 while (($#)); do
1222 case "$1" in 1642 case "$1" in
1643 -b|--base-path)
1644 base_path="1"
1645 ;;
1223 -f|--final-ABI) 1646 -f|--final-ABI)
1224 final_ABI="1" 1647 final_ABI="1"
1225 ;; 1648 ;;
1226 -*) 1649 -*)
1227 die "${FUNCNAME}(): Unrecognized option '$1'" 1650 die "${FUNCNAME}(): Unrecognized option '$1'"
1230 die "${FUNCNAME}(): Invalid usage" 1653 die "${FUNCNAME}(): Invalid usage"
1231 ;; 1654 ;;
1232 esac 1655 esac
1233 shift 1656 shift
1234 done 1657 done
1658
1659 if [[ "${base_path}" == "0" ]]; then
1660 prefix="/"
1661 fi
1235 1662
1236 if [[ "${final_ABI}" == "1" ]]; then 1663 if [[ "${final_ABI}" == "1" ]]; then
1237 if ! _python_package_supporting_installation_for_multiple_python_abis; then 1664 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1238 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 1665 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1239 fi 1666 fi
1240 PYTHON_ABI="$(PYTHON -f --ABI)" 1667 PYTHON_ABI="$(PYTHON -f --ABI)"
1241 elif [[ -z "${PYTHON_ABI}" ]]; then 1668 else
1669 if _python_package_supporting_installation_for_multiple_python_abis; then
1670 if ! _python_abi-specific_local_scope; then
1671 die "${FUNCNAME}() should be used in ABI-specific local scope"
1672 fi
1673 else
1242 PYTHON_ABI="$(PYTHON --ABI)" 1674 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
1675 fi
1243 fi 1676 fi
1244 1677
1245 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then 1678 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1246 echo "/usr/$(get_libdir)/python${PYTHON_ABI}" 1679 echo "${prefix}usr/$(get_libdir)/python${PYTHON_ABI}"
1247 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then 1680 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1248 echo "/usr/share/jython-${PYTHON_ABI%-jython}/Lib" 1681 echo "${prefix}usr/share/jython-${PYTHON_ABI%-jython}/Lib"
1249 fi 1682 fi
1250} 1683}
1251 1684
1252# @FUNCTION: python_get_sitedir 1685# @FUNCTION: python_get_sitedir
1253# @USAGE: [-f|--final-ABI] 1686# @USAGE: [-b|--base-path] [-f|--final-ABI]
1254# @DESCRIPTION: 1687# @DESCRIPTION:
1255# Print path to Python site-packages directory. 1688# Print path to Python site-packages directory.
1689# If --base-path option is specified, then path not prefixed with "/" is printed.
1256# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 1690# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1257python_get_sitedir() { 1691python_get_sitedir() {
1258 local options=() 1692 _python_check_python_pkg_setup_execution
1693
1694 local final_ABI="0" options=()
1259 1695
1260 while (($#)); do 1696 while (($#)); do
1261 case "$1" in 1697 case "$1" in
1698 -b|--base-path)
1699 options+=("$1")
1700 ;;
1262 -f|--final-ABI) 1701 -f|--final-ABI)
1263 if ! _python_package_supporting_installation_for_multiple_python_abis; then 1702 final_ABI="1"
1264 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1265 fi
1266 options+=("$1") 1703 options+=("$1")
1267 ;; 1704 ;;
1268 -*) 1705 -*)
1269 die "${FUNCNAME}(): Unrecognized option '$1'" 1706 die "${FUNCNAME}(): Unrecognized option '$1'"
1270 ;; 1707 ;;
1273 ;; 1710 ;;
1274 esac 1711 esac
1275 shift 1712 shift
1276 done 1713 done
1277 1714
1715 if [[ "${final_ABI}" == "1" ]]; then
1716 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1717 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1718 fi
1719 else
1720 if _python_package_supporting_installation_for_multiple_python_abis && ! _python_abi-specific_local_scope; then
1721 die "${FUNCNAME}() should be used in ABI-specific local scope"
1722 fi
1723 fi
1724
1278 echo "$(python_get_libdir "${options[@]}")/site-packages" 1725 echo "$(python_get_libdir "${options[@]}")/site-packages"
1279} 1726}
1280 1727
1281# @FUNCTION: python_get_library 1728# @FUNCTION: python_get_library
1282# @USAGE: [-f|--final-ABI] [-l|--linker-option] 1729# @USAGE: [-b|--base-path] [-f|--final-ABI] [-l|--linker-option]
1283# @DESCRIPTION: 1730# @DESCRIPTION:
1284# Print path to Python library. 1731# Print path to Python library.
1732# If --base-path option is specified, then path not prefixed with "/" is printed.
1285# If --linker-option is specified, then "-l${library}" linker option is printed. 1733# If --linker-option is specified, then "-l${library}" linker option is printed.
1286# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 1734# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1287python_get_library() { 1735python_get_library() {
1736 _python_check_python_pkg_setup_execution
1737
1288 local final_ABI="0" linker_option="0" PYTHON_ABI="${PYTHON_ABI}" 1738 local base_path="0" final_ABI="0" linker_option="0" prefix PYTHON_ABI="${PYTHON_ABI}"
1289 1739
1290 while (($#)); do 1740 while (($#)); do
1291 case "$1" in 1741 case "$1" in
1742 -b|--base-path)
1743 base_path="1"
1744 ;;
1292 -f|--final-ABI) 1745 -f|--final-ABI)
1293 final_ABI="1" 1746 final_ABI="1"
1294 ;; 1747 ;;
1295 -l|--linker-option) 1748 -l|--linker-option)
1296 linker_option="1" 1749 linker_option="1"
1302 die "${FUNCNAME}(): Invalid usage" 1755 die "${FUNCNAME}(): Invalid usage"
1303 ;; 1756 ;;
1304 esac 1757 esac
1305 shift 1758 shift
1306 done 1759 done
1760
1761 if [[ "${base_path}" == "0" ]]; then
1762 prefix="/"
1763 fi
1764
1765 if [[ "${base_path}" == "1" && "${linker_option}" == "1" ]]; then
1766 die "${FUNCNAME}(): '--base-path' and '--linker-option' options cannot be specified simultaneously"
1767 fi
1307 1768
1308 if [[ "${final_ABI}" == "1" ]]; then 1769 if [[ "${final_ABI}" == "1" ]]; then
1309 if ! _python_package_supporting_installation_for_multiple_python_abis; then 1770 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1310 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 1771 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1311 fi 1772 fi
1312 PYTHON_ABI="$(PYTHON -f --ABI)" 1773 PYTHON_ABI="$(PYTHON -f --ABI)"
1313 elif [[ -z "${PYTHON_ABI}" ]]; then 1774 else
1775 if _python_package_supporting_installation_for_multiple_python_abis; then
1776 if ! _python_abi-specific_local_scope; then
1777 die "${FUNCNAME}() should be used in ABI-specific local scope"
1778 fi
1779 else
1314 PYTHON_ABI="$(PYTHON --ABI)" 1780 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
1781 fi
1315 fi 1782 fi
1316 1783
1317 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then 1784 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1318 if [[ "${linker_option}" == "1" ]]; then 1785 if [[ "${linker_option}" == "1" ]]; then
1319 echo "-lpython${PYTHON_ABI}" 1786 echo "-lpython${PYTHON_ABI}"
1320 else 1787 else
1321 echo "/usr/$(get_libdir)/libpython${PYTHON_ABI}$(get_libname)" 1788 echo "${prefix}usr/$(get_libdir)/libpython${PYTHON_ABI}$(get_libname)"
1322 fi 1789 fi
1323 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then 1790 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1324 die "${FUNCNAME}(): Jython does not have shared library" 1791 die "${FUNCNAME}(): Jython does not have shared library"
1325 fi 1792 fi
1326} 1793}
1331# Print Python version. 1798# Print Python version.
1332# --full, --major, --minor and --micro options cannot be specified simultaneously. 1799# --full, --major, --minor and --micro options cannot be specified simultaneously.
1333# If --full, --major, --minor and --micro options are not specified, then "${major_version}.${minor_version}" is printed. 1800# If --full, --major, --minor and --micro options are not specified, then "${major_version}.${minor_version}" is printed.
1334# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 1801# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1335python_get_version() { 1802python_get_version() {
1803 _python_check_python_pkg_setup_execution
1804
1336 local final_ABI="0" full="0" major="0" minor="0" micro="0" python_command 1805 local final_ABI="0" full="0" major="0" minor="0" micro="0" python_command
1337 1806
1338 while (($#)); do 1807 while (($#)); do
1339 case "$1" in 1808 case "$1" in
1340 -f|--final-ABI) 1809 -f|--final-ABI)
1390 if ! _python_package_supporting_installation_for_multiple_python_abis; then 1859 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1391 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 1860 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1392 fi 1861 fi
1393 "$(PYTHON -f)" -c "${python_command}" 1862 "$(PYTHON -f)" -c "${python_command}"
1394 else 1863 else
1864 if _python_package_supporting_installation_for_multiple_python_abis && ! _python_abi-specific_local_scope; then
1865 die "${FUNCNAME}() should be used in ABI-specific local scope"
1866 fi
1395 "$(PYTHON ${PYTHON_ABI})" -c "${python_command}" 1867 "$(PYTHON ${PYTHON_ABI})" -c "${python_command}"
1396 fi 1868 fi
1397}
1398
1399# ================================================================================================
1400# =================================== MISCELLANEOUS FUNCTIONS ====================================
1401# ================================================================================================
1402
1403_python_implementation() {
1404 if [[ "${CATEGORY}/${PN}" == "dev-lang/python" ]]; then
1405 return 0
1406 elif [[ "${CATEGORY}/${PN}" == "dev-java/jython" ]]; then
1407 return 0
1408 else
1409 return 1
1410 fi
1411}
1412
1413_python_package_supporting_installation_for_multiple_python_abis() {
1414 if [[ "${EBUILD_PHASE}" == "depend" ]]; then
1415 die "${FUNCNAME}() cannot be used in global scope"
1416 fi
1417
1418 if has "${EAPI:-0}" 0 1 2 3 4; then
1419 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
1420 return 0
1421 else
1422 return 1
1423 fi
1424 else
1425 die "${FUNCNAME}(): Support for EAPI=\"${EAPI}\" not implemented"
1426 fi
1427}
1428
1429_python_initialize_prefix_variables() {
1430 if has "${EAPI:-0}" 0 1 2; then
1431 if [[ -n "${ROOT}" && -z "${EROOT}" ]]; then
1432 EROOT="${ROOT%/}${EPREFIX}/"
1433 fi
1434 if [[ -n "${D}" && -z "${ED}" ]]; then
1435 ED="${D%/}${EPREFIX}/"
1436 fi
1437 fi
1438}
1439
1440unset PYTHON_SANITY_CHECKS
1441
1442_python_initial_sanity_checks() {
1443 if [[ "$(declare -p PYTHON_SANITY_CHECKS 2> /dev/null)" != "declare -- PYTHON_SANITY_CHECKS="* ]]; then
1444 # Ensure that /usr/bin/python and /usr/bin/python-config are valid.
1445 if [[ "$(readlink "${EPREFIX}/usr/bin/python")" != "python-wrapper" ]]; then
1446 eerror "'${EPREFIX}/usr/bin/python' is not valid symlink."
1447 eerror "Use \`eselect python set \${python_interpreter}\` to fix this problem."
1448 die "'${EPREFIX}/usr/bin/python' is not valid symlink"
1449 fi
1450 if [[ "$(<"${EPREFIX}/usr/bin/python-config")" != *"Gentoo python-config wrapper script"* ]]; then
1451 eerror "'${EPREFIX}/usr/bin/python-config' is not valid script"
1452 eerror "Use \`eselect python set \${python_interpreter}\` to fix this problem."
1453 die "'${EPREFIX}/usr/bin/python-config' is not valid script"
1454 fi
1455 fi
1456}
1457
1458_python_final_sanity_checks() {
1459 if ! _python_implementation && [[ "$(declare -p PYTHON_SANITY_CHECKS 2> /dev/null)" != "declare -- PYTHON_SANITY_CHECKS="* ]]; then
1460 local PYTHON_ABI="${PYTHON_ABI}"
1461 for PYTHON_ABI in ${PYTHON_ABIS-${PYTHON_ABI}}; do
1462 # Ensure that appropriate version of Python is installed.
1463 if ! has_version "$(python_get_implementational_package)"; then
1464 die "$(python_get_implementational_package) is not installed"
1465 fi
1466
1467 # Ensure that EPYTHON variable is respected.
1468 if [[ "$(EPYTHON="$(PYTHON)" python -c "${_PYTHON_ABI_EXTRACTION_COMMAND}")" != "${PYTHON_ABI}" ]]; then
1469 eerror "python: '$(type -p python)'"
1470 eerror "ABI: '${ABI}'"
1471 eerror "DEFAULT_ABI: '${DEFAULT_ABI}'"
1472 eerror "EPYTHON: '$(PYTHON)'"
1473 eerror "PYTHON_ABI: '${PYTHON_ABI}'"
1474 eerror "Version of enabled Python: '$(EPYTHON="$(PYTHON)" python -c "${_PYTHON_ABI_EXTRACTION_COMMAND}")'"
1475 die "'python' does not respect EPYTHON variable"
1476 fi
1477 done
1478 fi
1479 PYTHON_SANITY_CHECKS="1"
1480}
1481
1482_python_set_color_variables() {
1483 if [[ "${NOCOLOR:-false}" =~ ^(false|no)$ ]]; then
1484 _BOLD=$'\e[1m'
1485 _RED=$'\e[1;31m'
1486 _GREEN=$'\e[1;32m'
1487 _BLUE=$'\e[1;34m'
1488 _CYAN=$'\e[1;36m'
1489 _NORMAL=$'\e[0m'
1490 else
1491 _BOLD=
1492 _RED=
1493 _GREEN=
1494 _BLUE=
1495 _CYAN=
1496 _NORMAL=
1497 fi
1498}
1499
1500# @FUNCTION: python_convert_shebangs
1501# @USAGE: [-q|--quiet] [-r|--recursive] [-x|--only-executables] [--] <Python_version> <file|directory> [files|directories]
1502# @DESCRIPTION:
1503# Convert shebangs in specified files. Directories can be specified only with --recursive option.
1504python_convert_shebangs() {
1505 local argument file files=() only_executables="0" python_version quiet="0" recursive="0"
1506
1507 while (($#)); do
1508 case "$1" in
1509 -r|--recursive)
1510 recursive="1"
1511 ;;
1512 -q|--quiet)
1513 quiet="1"
1514 ;;
1515 -x|--only-executables)
1516 only_executables="1"
1517 ;;
1518 --)
1519 shift
1520 break
1521 ;;
1522 -*)
1523 die "${FUNCNAME}(): Unrecognized option '$1'"
1524 ;;
1525 *)
1526 break
1527 ;;
1528 esac
1529 shift
1530 done
1531
1532 if [[ "$#" -eq 0 ]]; then
1533 die "${FUNCNAME}(): Missing Python version and files or directories"
1534 elif [[ "$#" -eq 1 ]]; then
1535 die "${FUNCNAME}(): Missing files or directories"
1536 fi
1537
1538 python_version="$1"
1539 shift
1540
1541 for argument in "$@"; do
1542 if [[ ! -e "${argument}" ]]; then
1543 die "${FUNCNAME}(): '${argument}' does not exist"
1544 elif [[ -f "${argument}" ]]; then
1545 files+=("${argument}")
1546 elif [[ -d "${argument}" ]]; then
1547 if [[ "${recursive}" == "1" ]]; then
1548 while read -d $'\0' -r file; do
1549 files+=("${file}")
1550 done < <(find "${argument}" $([[ "${only_executables}" == "1" ]] && echo -perm /111) -type f -print0)
1551 else
1552 die "${FUNCNAME}(): '${argument}' is not a regular file"
1553 fi
1554 else
1555 die "${FUNCNAME}(): '${argument}' is not a regular file or a directory"
1556 fi
1557 done
1558
1559 for file in "${files[@]}"; do
1560 file="${file#./}"
1561 [[ "${only_executables}" == "1" && ! -x "${file}" ]] && continue
1562
1563 if [[ "$(head -n1 "${file}")" =~ ^'#!'.*python ]]; then
1564 [[ "$(sed -ne "2p" "${file}")" =~ ^"# Gentoo '".*"' wrapper script generated by python_generate_wrapper_scripts()"$ ]] && continue
1565
1566 if [[ "${quiet}" == "0" ]]; then
1567 einfo "Converting shebang in '${file}'"
1568 fi
1569
1570 sed -e "1s/python\([[:digit:]]\+\(\.[[:digit:]]\+\)\?\)\?/python${python_version}/" -i "${file}" || die "Conversion of shebang in '${file}' failed"
1571
1572 # Delete potential whitespace after "#!".
1573 sed -e '1s/\(^#!\)[[:space:]]*/\1/' -i "${file}" || die "sed '${file}' failed"
1574 fi
1575 done
1576}
1577
1578# @FUNCTION: python_clean_sitedirs
1579# @DESCRIPTION:
1580# Delete needless files in site-packages directories in ${ED}.
1581python_clean_sitedirs() {
1582 _python_initialize_prefix_variables
1583
1584 find "${ED}"usr/$(get_libdir)/python*/site-packages "(" -name "*.c" -o -name "*.h" -o -name "*.la" ")" -type f -print0 | xargs -0 rm -f
1585} 1869}
1586 1870
1587# ================================================================================================ 1871# ================================================================================================
1588# ================================ FUNCTIONS FOR RUNNING OF TESTS ================================ 1872# ================================ FUNCTIONS FOR RUNNING OF TESTS ================================
1589# ================================================================================================ 1873# ================================================================================================
1609# @DESCRIPTION: 1893# @DESCRIPTION:
1610# Execute nosetests for all enabled Python ABIs. 1894# Execute nosetests for all enabled Python ABIs.
1611# In ebuilds of packages supporting installation for multiple Python ABIs, this function calls 1895# In ebuilds of packages supporting installation for multiple Python ABIs, this function calls
1612# python_execute_nosetests_pre_hook() and python_execute_nosetests_post_hook(), if they are defined. 1896# python_execute_nosetests_pre_hook() and python_execute_nosetests_post_hook(), if they are defined.
1613python_execute_nosetests() { 1897python_execute_nosetests() {
1898 _python_check_python_pkg_setup_execution
1614 _python_set_color_variables 1899 _python_set_color_variables
1615 1900
1616 local PYTHONPATH_template= separate_build_dirs= 1901 local PYTHONPATH_template= separate_build_dirs=
1617 1902
1618 while (($#)); do 1903 while (($#)); do
1637 esac 1922 esac
1638 shift 1923 shift
1639 done 1924 done
1640 1925
1641 python_test_function() { 1926 python_test_function() {
1642 local evaluated_PYTHONPATH= 1927 local evaluated_PYTHONPATH
1643 1928
1644 if [[ -n "${PYTHONPATH_template}" ]]; then
1645 evaluated_PYTHONPATH="$(eval echo -n "${PYTHONPATH_template}")" 1929 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\""
1646 if [[ ! -e "${evaluated_PYTHONPATH}" ]]; then
1647 unset evaluated_PYTHONPATH
1648 fi
1649 fi
1650 1930
1651 _python_test_hook pre 1931 _python_test_hook pre
1652 1932
1653 if [[ -n "${evaluated_PYTHONPATH}" ]]; then 1933 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
1654 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@"${_NORMAL} 1934 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@"${_NORMAL}
1677# @DESCRIPTION: 1957# @DESCRIPTION:
1678# Execute py.test for all enabled Python ABIs. 1958# Execute py.test for all enabled Python ABIs.
1679# In ebuilds of packages supporting installation for multiple Python ABIs, this function calls 1959# In ebuilds of packages supporting installation for multiple Python ABIs, this function calls
1680# python_execute_py.test_pre_hook() and python_execute_py.test_post_hook(), if they are defined. 1960# python_execute_py.test_pre_hook() and python_execute_py.test_post_hook(), if they are defined.
1681python_execute_py.test() { 1961python_execute_py.test() {
1962 _python_check_python_pkg_setup_execution
1682 _python_set_color_variables 1963 _python_set_color_variables
1683 1964
1684 local PYTHONPATH_template= separate_build_dirs= 1965 local PYTHONPATH_template= separate_build_dirs=
1685 1966
1686 while (($#)); do 1967 while (($#)); do
1705 esac 1986 esac
1706 shift 1987 shift
1707 done 1988 done
1708 1989
1709 python_test_function() { 1990 python_test_function() {
1710 local evaluated_PYTHONPATH= 1991 local evaluated_PYTHONPATH
1711 1992
1712 if [[ -n "${PYTHONPATH_template}" ]]; then
1713 evaluated_PYTHONPATH="$(eval echo -n "${PYTHONPATH_template}")" 1993 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\""
1714 if [[ ! -e "${evaluated_PYTHONPATH}" ]]; then
1715 unset evaluated_PYTHONPATH
1716 fi
1717 fi
1718 1994
1719 _python_test_hook pre 1995 _python_test_hook pre
1720 1996
1721 if [[ -n "${evaluated_PYTHONPATH}" ]]; then 1997 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
1722 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@"${_NORMAL} 1998 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@"${_NORMAL}
1745# @DESCRIPTION: 2021# @DESCRIPTION:
1746# Execute trial for all enabled Python ABIs. 2022# Execute trial for all enabled Python ABIs.
1747# In ebuilds of packages supporting installation for multiple Python ABIs, this function 2023# In ebuilds of packages supporting installation for multiple Python ABIs, this function
1748# calls python_execute_trial_pre_hook() and python_execute_trial_post_hook(), if they are defined. 2024# calls python_execute_trial_pre_hook() and python_execute_trial_post_hook(), if they are defined.
1749python_execute_trial() { 2025python_execute_trial() {
2026 _python_check_python_pkg_setup_execution
1750 _python_set_color_variables 2027 _python_set_color_variables
1751 2028
1752 local PYTHONPATH_template= separate_build_dirs= 2029 local PYTHONPATH_template= separate_build_dirs=
1753 2030
1754 while (($#)); do 2031 while (($#)); do
1773 esac 2050 esac
1774 shift 2051 shift
1775 done 2052 done
1776 2053
1777 python_test_function() { 2054 python_test_function() {
1778 local evaluated_PYTHONPATH= 2055 local evaluated_PYTHONPATH
1779 2056
1780 if [[ -n "${PYTHONPATH_template}" ]]; then
1781 evaluated_PYTHONPATH="$(eval echo -n "${PYTHONPATH_template}")" 2057 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\""
1782 if [[ ! -e "${evaluated_PYTHONPATH}" ]]; then
1783 unset evaluated_PYTHONPATH
1784 fi
1785 fi
1786 2058
1787 _python_test_hook pre 2059 _python_test_hook pre
1788 2060
1789 if [[ -n "${evaluated_PYTHONPATH}" ]]; then 2061 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
1790 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@"${_NORMAL} 2062 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@"${_NORMAL}
1815# @FUNCTION: python_enable_pyc 2087# @FUNCTION: python_enable_pyc
1816# @DESCRIPTION: 2088# @DESCRIPTION:
1817# Tell Python to automatically recompile modules to .pyc/.pyo if the 2089# Tell Python to automatically recompile modules to .pyc/.pyo if the
1818# timestamps/version stamps have changed. 2090# timestamps/version stamps have changed.
1819python_enable_pyc() { 2091python_enable_pyc() {
2092 _python_check_python_pkg_setup_execution
2093
2094 if [[ "$#" -ne 0 ]]; then
2095 die "${FUNCNAME}() does not accept arguments"
2096 fi
2097
1820 unset PYTHONDONTWRITEBYTECODE 2098 unset PYTHONDONTWRITEBYTECODE
1821} 2099}
1822 2100
1823# @FUNCTION: python_disable_pyc 2101# @FUNCTION: python_disable_pyc
1824# @DESCRIPTION: 2102# @DESCRIPTION:
1825# Tell Python not to automatically recompile modules to .pyc/.pyo 2103# Tell Python not to automatically recompile modules to .pyc/.pyo
1826# even if the timestamps/version stamps do not match. This is done 2104# even if the timestamps/version stamps do not match. This is done
1827# to protect sandbox. 2105# to protect sandbox.
1828python_disable_pyc() { 2106python_disable_pyc() {
2107 _python_check_python_pkg_setup_execution
2108
2109 if [[ "$#" -ne 0 ]]; then
2110 die "${FUNCNAME}() does not accept arguments"
2111 fi
2112
1829 export PYTHONDONTWRITEBYTECODE="1" 2113 export PYTHONDONTWRITEBYTECODE="1"
1830} 2114}
1831 2115
2116_python_clean_compiled_modules() {
2117 _python_initialize_prefix_variables
2118 _python_set_color_variables
2119
2120 [[ "${FUNCNAME[1]}" =~ ^(python_mod_optimize|python_mod_cleanup)$ ]] || die "${FUNCNAME}(): Invalid usage"
2121
2122 local base_module_name compiled_file compiled_files=() dir path py_file root
2123
2124 # Strip trailing slash from EROOT.
2125 root="${EROOT%/}"
2126
2127 for path in "$@"; do
2128 compiled_files=()
2129 if [[ -d "${path}" ]]; then
2130 while read -d $'\0' -r compiled_file; do
2131 compiled_files+=("${compiled_file}")
2132 done < <(find "${path}" "(" -name "*.py[co]" -o -name "*\$py.class" ")" -print0)
2133
2134 if [[ "${EBUILD_PHASE}" == "postrm" ]]; then
2135 # Delete empty child directories.
2136 find "${path}" -type d | sort -r | while read -r dir; do
2137 if rmdir "${dir}" 2> /dev/null; then
2138 echo "${_CYAN}<<< ${dir}${_NORMAL}"
2139 fi
2140 done
2141 fi
2142 elif [[ "${path}" == *.py ]]; then
2143 base_module_name="${path##*/}"
2144 base_module_name="${base_module_name%.py}"
2145 if [[ -d "${path%/*}/__pycache__" ]]; then
2146 while read -d $'\0' -r compiled_file; do
2147 compiled_files+=("${compiled_file}")
2148 done < <(find "${path%/*}/__pycache__" "(" -name "${base_module_name}.*.py[co]" -o -name "${base_module_name}\$py.class" ")" -print0)
2149 fi
2150 compiled_files+=("${path}c" "${path}o" "${path%.py}\$py.class")
2151 fi
2152
2153 for compiled_file in "${compiled_files[@]}"; do
2154 [[ ! -f "${compiled_file}" ]] && continue
2155 dir="${compiled_file%/*}"
2156 dir="${dir##*/}"
2157 if [[ "${compiled_file}" == *.py[co] ]]; then
2158 if [[ "${dir}" == "__pycache__" ]]; then
2159 base_module_name="${compiled_file##*/}"
2160 base_module_name="${base_module_name%.*py[co]}"
2161 base_module_name="${base_module_name%.*}"
2162 py_file="${compiled_file%__pycache__/*}${base_module_name}.py"
2163 else
2164 py_file="${compiled_file%[co]}"
2165 fi
2166 if [[ "${EBUILD_PHASE}" == "postinst" ]]; then
2167 [[ -f "${py_file}" && "${compiled_file}" -nt "${py_file}" ]] && continue
2168 else
2169 [[ -f "${py_file}" ]] && continue
2170 fi
2171 echo "${_BLUE}<<< ${compiled_file%[co]}[co]${_NORMAL}"
2172 rm -f "${compiled_file%[co]}"[co]
2173 elif [[ "${compiled_file}" == *\$py.class ]]; then
2174 if [[ "${dir}" == "__pycache__" ]]; then
2175 base_module_name="${compiled_file##*/}"
2176 base_module_name="${base_module_name%\$py.class}"
2177 py_file="${compiled_file%__pycache__/*}${base_module_name}.py"
2178 else
2179 py_file="${compiled_file%\$py.class}"
2180 fi
2181 if [[ "${EBUILD_PHASE}" == "postinst" ]]; then
2182 [[ -f "${py_file}" && "${compiled_file}" -nt "${py_file}" ]] && continue
2183 else
2184 [[ -f "${py_file}" ]] && continue
2185 fi
2186 echo "${_BLUE}<<< ${compiled_file}${_NORMAL}"
2187 rm -f "${compiled_file}"
2188 else
2189 die "${FUNCNAME}(): Unrecognized file type: '${compiled_file}'"
2190 fi
2191
2192 # Delete empty parent directories.
2193 dir="${compiled_file%/*}"
2194 while [[ "${dir}" != "${root}" ]]; do
2195 if rmdir "${dir}" 2> /dev/null; then
2196 echo "${_CYAN}<<< ${dir}${_NORMAL}"
2197 else
2198 break
2199 fi
2200 dir="${dir%/*}"
2201 done
2202 done
2203 done
2204}
2205
1832# @FUNCTION: python_mod_optimize 2206# @FUNCTION: python_mod_optimize
1833# @USAGE: [options] [directory|file] 2207# @USAGE: [--allow-evaluated-non-sitedir-paths] [-d directory] [-f] [-l] [-q] [-x regular_expression] [--] <file|directory> [files|directories]
1834# @DESCRIPTION: 2208# @DESCRIPTION:
1835# If no arguments supplied, it will recompile not recursively all modules 2209# Byte-compile specified Python modules.
1836# under sys.path (eg. /usr/lib/python2.6, /usr/lib/python2.6/site-packages).
1837#
1838# If supplied with arguments, it will recompile all modules recursively
1839# in the supplied directory.
1840#
1841# Options passed to this function are passed to compileall.py. 2210# -d, -f, -l, -q and -x options passed to this function are passed to compileall.py.
1842# 2211#
1843# This function can be used only in pkg_postinst() phase. 2212# This function can be used only in pkg_postinst() phase.
1844python_mod_optimize() { 2213python_mod_optimize() {
2214 _python_check_python_pkg_setup_execution
1845 _python_initialize_prefix_variables 2215 _python_initialize_prefix_variables
1846 2216
1847 # Check if phase is pkg_postinst(). 2217 # Check if phase is pkg_postinst().
1848 [[ "${EBUILD_PHASE}" != "postinst" ]] && die "${FUNCNAME}() can be used only in pkg_postinst() phase" 2218 [[ "${EBUILD_PHASE}" != "postinst" ]] && die "${FUNCNAME}() can be used only in pkg_postinst() phase"
1849 2219
2220 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis || _python_implementation || [[ "${CATEGORY}/${PN}" == "sys-apps/portage" ]]; then
2221 # PYTHON_ABI variable cannot be local in packages not supporting installation for multiple Python ABIs.
2222 local allow_evaluated_non_sitedir_paths="0" dir dirs=() evaluated_dirs=() evaluated_files=() file files=() iterated_PYTHON_ABIS options=() other_dirs=() other_files=() previous_PYTHON_ABI="${PYTHON_ABI}" return_code root site_packages_dirs=() site_packages_files=()
2223
1850 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis; then 2224 if _python_package_supporting_installation_for_multiple_python_abis; then
1851 local dir file options=() other_dirs=() other_files=() previous_PYTHON_ABI="${PYTHON_ABI}" PYTHON_ABI="${PYTHON_ABI}" return_code root site_packages_absolute_dirs=() site_packages_dirs=() site_packages_absolute_files=() site_packages_files=() 2225 if has "${EAPI:-0}" 0 1 2 3 && [[ -z "${PYTHON_ABIS}" ]]; then
2226 die "${FUNCNAME}(): python_pkg_setup() or python_execute_function() not called"
2227 fi
2228 iterated_PYTHON_ABIS="${PYTHON_ABIS}"
2229 else
2230 if has "${EAPI:-0}" 0 1 2 3; then
2231 iterated_PYTHON_ABIS="${PYTHON_ABI:=$(PYTHON --ABI)}"
2232 else
2233 iterated_PYTHON_ABIS="${PYTHON_ABI}"
2234 fi
2235 fi
1852 2236
1853 # Strip trailing slash from ROOT. 2237 # Strip trailing slash from EROOT.
1854 root="${EROOT%/}" 2238 root="${EROOT%/}"
1855 2239
1856 # Respect ROOT and options passed to compileall.py.
1857 while (($#)); do 2240 while (($#)); do
1858 case "$1" in 2241 case "$1" in
2242 --allow-evaluated-non-sitedir-paths)
2243 allow_evaluated_non_sitedir_paths="1"
2244 ;;
1859 -l|-f|-q) 2245 -l|-f|-q)
1860 options+=("$1") 2246 options+=("$1")
1861 ;; 2247 ;;
1862 -d|-x) 2248 -d|-x)
1863 options+=("$1" "$2") 2249 options+=("$1" "$2")
1864 shift 2250 shift
1865 ;; 2251 ;;
2252 --)
2253 shift
2254 break
2255 ;;
1866 -*) 2256 -*)
1867 ewarn "${FUNCNAME}(): Ignoring option '$1'" 2257 die "${FUNCNAME}(): Unrecognized option '$1'"
1868 ;; 2258 ;;
1869 *) 2259 *)
1870 if ! _python_implementation && [[ "$1" =~ ^"${EPREFIX}"/usr/lib(32|64)?/python[[:digit:]]+\.[[:digit:]]+ ]]; then
1871 die "${FUNCNAME}() does not support absolute paths of directories/files in site-packages directories"
1872 elif [[ "$1" =~ ^/ ]]; then
1873 if [[ -d "${root}/$1" ]]; then
1874 other_dirs+=("${root}/$1")
1875 elif [[ -f "${root}/$1" ]]; then
1876 other_files+=("${root}/$1")
1877 elif [[ -e "${root}/$1" ]]; then
1878 ewarn "'${root}/$1' is not a file or a directory!"
1879 else
1880 ewarn "'${root}/$1' does not exist!"
1881 fi
1882 else
1883 for PYTHON_ABI in ${PYTHON_ABIS-${PYTHON_ABI:-$(PYTHON --ABI)}}; do
1884 if [[ -d "${root}$(python_get_sitedir)/$1" ]]; then
1885 site_packages_dirs+=("$1")
1886 break 2260 break
1887 elif [[ -f "${root}$(python_get_sitedir)/$1" ]]; then
1888 site_packages_files+=("$1")
1889 break
1890 elif [[ -e "${root}$(python_get_sitedir)/$1" ]]; then
1891 ewarn "'$1' is not a file or a directory!"
1892 else
1893 ewarn "'$1' does not exist!"
1894 fi
1895 done
1896 fi
1897 ;; 2261 ;;
1898 esac 2262 esac
1899 shift 2263 shift
1900 done 2264 done
1901 2265
2266 if [[ "${allow_evaluated_non_sitedir_paths}" == "1" ]] && ! _python_package_supporting_installation_for_multiple_python_abis; then
2267 die "${FUNCNAME}(): '--allow-evaluated-non-sitedir-paths' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2268 fi
2269
2270 if [[ "$#" -eq 0 ]]; then
2271 die "${FUNCNAME}(): Missing files or directories"
2272 fi
2273
2274 while (($#)); do
2275 if [[ "$1" =~ ^($|(\.|\.\.|/)($|/)) ]]; then
2276 die "${FUNCNAME}(): Invalid argument '$1'"
2277 elif ! _python_implementation && [[ "$1" =~ ^/usr/lib(32|64)?/python[[:digit:]]+\.[[:digit:]]+ ]]; then
2278 die "${FUNCNAME}(): Paths of directories / files in site-packages directories must be relative to site-packages directories"
2279 elif [[ "$1" =~ ^/ ]]; then
2280 if _python_package_supporting_installation_for_multiple_python_abis; then
2281 if [[ "${allow_evaluated_non_sitedir_paths}" != "1" ]]; then
2282 die "${FUNCNAME}(): Absolute paths cannot be used in ebuilds of packages supporting installation for multiple Python ABIs"
2283 fi
2284 if [[ "$1" != *\$* ]]; then
2285 die "${FUNCNAME}(): '$1' has invalid syntax"
2286 fi
2287 if [[ "$1" == *.py ]]; then
2288 evaluated_files+=("$1")
2289 else
2290 evaluated_dirs+=("$1")
2291 fi
2292 else
2293 if [[ -d "${root}$1" ]]; then
2294 other_dirs+=("${root}$1")
2295 elif [[ -f "${root}$1" ]]; then
2296 other_files+=("${root}$1")
2297 elif [[ -e "${root}$1" ]]; then
2298 eerror "${FUNCNAME}(): '${root}$1' is not a regular file or a directory"
2299 else
2300 eerror "${FUNCNAME}(): '${root}$1' does not exist"
2301 fi
2302 fi
2303 else
2304 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
2305 if [[ -d "${root}$(python_get_sitedir)/$1" ]]; then
2306 site_packages_dirs+=("$1")
2307 break
2308 elif [[ -f "${root}$(python_get_sitedir)/$1" ]]; then
2309 site_packages_files+=("$1")
2310 break
2311 elif [[ -e "${root}$(python_get_sitedir)/$1" ]]; then
2312 eerror "${FUNCNAME}(): '$1' is not a regular file or a directory"
2313 else
2314 eerror "${FUNCNAME}(): '$1' does not exist"
2315 fi
2316 done
2317 fi
2318 shift
2319 done
2320
1902 # Set additional options. 2321 # Set additional options.
1903 options+=("-q") 2322 options+=("-q")
1904 2323
1905 for PYTHON_ABI in ${PYTHON_ABIS-${PYTHON_ABI:-$(PYTHON --ABI)}}; do 2324 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
1906 if ((${#site_packages_dirs[@]})) || ((${#site_packages_files[@]})); then 2325 if ((${#site_packages_dirs[@]})) || ((${#site_packages_files[@]})) || ((${#evaluated_dirs[@]})) || ((${#evaluated_files[@]})); then
1907 return_code="0" 2326 return_code="0"
1908 ebegin "Compilation and optimization of Python modules for $(python_get_implementation) $(python_get_version)" 2327 ebegin "Compilation and optimization of Python modules for $(python_get_implementation) $(python_get_version)"
1909 if ((${#site_packages_dirs[@]})); then 2328 if ((${#site_packages_dirs[@]})) || ((${#evaluated_dirs[@]})); then
1910 for dir in "${site_packages_dirs[@]}"; do 2329 for dir in "${site_packages_dirs[@]}"; do
1911 site_packages_absolute_dirs+=("${root}$(python_get_sitedir)/${dir}") 2330 dirs+=("${root}$(python_get_sitedir)/${dir}")
1912 done 2331 done
2332 for dir in "${evaluated_dirs[@]}"; do
2333 eval "dirs+=(\"\${root}${dir}\")"
2334 done
1913 "$(PYTHON)" "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${site_packages_absolute_dirs[@]}" || return_code="1" 2335 "$(PYTHON)" "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${dirs[@]}" || return_code="1"
1914 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then 2336 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then
1915 "$(PYTHON)" -O "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${site_packages_absolute_dirs[@]}" &> /dev/null || return_code="1" 2337 "$(PYTHON)" -O "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${dirs[@]}" &> /dev/null || return_code="1"
1916 fi 2338 fi
2339 _python_clean_compiled_modules "${dirs[@]}"
1917 fi 2340 fi
1918 if ((${#site_packages_files[@]})); then 2341 if ((${#site_packages_files[@]})) || ((${#evaluated_files[@]})); then
1919 for file in "${site_packages_files[@]}"; do 2342 for file in "${site_packages_files[@]}"; do
1920 site_packages_absolute_files+=("${root}$(python_get_sitedir)/${file}") 2343 files+=("${root}$(python_get_sitedir)/${file}")
1921 done 2344 done
2345 for file in "${evaluated_files[@]}"; do
2346 eval "files+=(\"\${root}${file}\")"
2347 done
1922 "$(PYTHON)" "${root}$(python_get_libdir)/py_compile.py" "${site_packages_absolute_files[@]}" || return_code="1" 2348 "$(PYTHON)" "${root}$(python_get_libdir)/py_compile.py" "${files[@]}" || return_code="1"
1923 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then 2349 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then
1924 "$(PYTHON)" -O "${root}$(python_get_libdir)/py_compile.py" "${site_packages_absolute_files[@]}" &> /dev/null || return_code="1" 2350 "$(PYTHON)" -O "${root}$(python_get_libdir)/py_compile.py" "${files[@]}" &> /dev/null || return_code="1"
1925 fi 2351 fi
2352 _python_clean_compiled_modules "${files[@]}"
1926 fi 2353 fi
1927 eend "${return_code}" 2354 eend "${return_code}"
1928 fi 2355 fi
1929 unset site_packages_absolute_dirs site_packages_absolute_files 2356 unset dirs files
1930 done 2357 done
1931 2358
2359 if _python_package_supporting_installation_for_multiple_python_abis; then
1932 # Restore previous value of PYTHON_ABI. 2360 # Restore previous value of PYTHON_ABI.
1933 if [[ -n "${previous_PYTHON_ABI}" ]]; then 2361 if [[ -n "${previous_PYTHON_ABI}" ]]; then
1934 PYTHON_ABI="${previous_PYTHON_ABI}" 2362 PYTHON_ABI="${previous_PYTHON_ABI}"
1935 else 2363 else
1936 unset PYTHON_ABI 2364 unset PYTHON_ABI
2365 fi
1937 fi 2366 fi
1938 2367
1939 if ((${#other_dirs[@]})) || ((${#other_files[@]})); then 2368 if ((${#other_dirs[@]})) || ((${#other_files[@]})); then
1940 return_code="0" 2369 return_code="0"
1941 ebegin "Compilation and optimization of Python modules placed outside of site-packages directories for $(python_get_implementation) $(python_get_version)" 2370 ebegin "Compilation and optimization of Python modules placed outside of site-packages directories for $(python_get_implementation) $(python_get_version)"
1942 if ((${#other_dirs[@]})); then 2371 if ((${#other_dirs[@]})); then
1943 "$(PYTHON ${PYTHON_ABI})" "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${other_dirs[@]}" || return_code="1" 2372 "$(PYTHON ${PYTHON_ABI})" "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${other_dirs[@]}" || return_code="1"
1944 if [[ "$(_python_get_implementation "${PYTHON_ABI-$(PYTHON --ABI)}")" != "Jython" ]]; then 2373 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then
1945 "$(PYTHON ${PYTHON_ABI})" -O "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${other_dirs[@]}" &> /dev/null || return_code="1" 2374 "$(PYTHON ${PYTHON_ABI})" -O "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${other_dirs[@]}" &> /dev/null || return_code="1"
1946 fi 2375 fi
2376 _python_clean_compiled_modules "${other_dirs[@]}"
1947 fi 2377 fi
1948 if ((${#other_files[@]})); then 2378 if ((${#other_files[@]})); then
1949 "$(PYTHON ${PYTHON_ABI})" "${root}$(python_get_libdir)/py_compile.py" "${other_files[@]}" || return_code="1" 2379 "$(PYTHON ${PYTHON_ABI})" "${root}$(python_get_libdir)/py_compile.py" "${other_files[@]}" || return_code="1"
1950 if [[ "$(_python_get_implementation "${PYTHON_ABI-$(PYTHON --ABI)}")" != "Jython" ]]; then 2380 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then
1951 "$(PYTHON ${PYTHON_ABI})" -O "${root}$(python_get_libdir)/py_compile.py" "${other_files[@]}" &> /dev/null || return_code="1" 2381 "$(PYTHON ${PYTHON_ABI})" -O "${root}$(python_get_libdir)/py_compile.py" "${other_files[@]}" &> /dev/null || return_code="1"
1952 fi 2382 fi
2383 _python_clean_compiled_modules "${other_files[@]}"
1953 fi 2384 fi
1954 eend "${return_code}" 2385 eend "${return_code}"
1955 fi 2386 fi
1956 else 2387 else
2388 # Deprecated part of python_mod_optimize()
2389 # ewarn
2390 # ewarn "Deprecation Warning: Usage of ${FUNCNAME}() in packages not supporting installation"
2391 # ewarn "for multiple Python ABIs in EAPI <=2 is deprecated and will be disallowed on 2011-06-01."
2392 # ewarn "Use EAPI >=3 and call ${FUNCNAME}() with paths having appropriate syntax."
2393 # ewarn "The ebuild needs to be fixed. Please report a bug, if it has not been already reported."
2394 # ewarn
2395
1957 local myroot mydirs=() myfiles=() myopts=() return_code="0" 2396 local myroot mydirs=() myfiles=() myopts=() return_code="0"
1958 2397
1959 # strip trailing slash 2398 # strip trailing slash
1960 myroot="${EROOT%/}" 2399 myroot="${EROOT%/}"
1961 2400
1962 # respect ROOT and options passed to compileall.py 2401 # respect EROOT and options passed to compileall.py
1963 while (($#)); do 2402 while (($#)); do
1964 case "$1" in 2403 case "$1" in
1965 -l|-f|-q) 2404 -l|-f|-q)
1966 myopts+=("$1") 2405 myopts+=("$1")
1967 ;; 2406 ;;
1968 -d|-x) 2407 -d|-x)
1969 myopts+=("$1" "$2") 2408 myopts+=("$1" "$2")
1970 shift 2409 shift
1971 ;; 2410 ;;
2411 --)
2412 shift
2413 break
2414 ;;
1972 -*) 2415 -*)
1973 ewarn "${FUNCNAME}(): Ignoring option '$1'" 2416 die "${FUNCNAME}(): Unrecognized option '$1'"
1974 ;; 2417 ;;
1975 *) 2418 *)
1976 if [[ -d "${myroot}"/$1 ]]; then 2419 break
1977 mydirs+=("${myroot}/$1")
1978 elif [[ -f "${myroot}"/$1 ]]; then
1979 # Files are passed to python_mod_compile which is ROOT-aware
1980 myfiles+=("$1")
1981 elif [[ -e "${myroot}/$1" ]]; then
1982 ewarn "${myroot}/$1 is not a file or directory!"
1983 else
1984 ewarn "${myroot}/$1 does not exist!"
1985 fi
1986 ;; 2420 ;;
1987 esac 2421 esac
1988 shift 2422 shift
1989 done 2423 done
1990 2424
2425 if [[ "$#" -eq 0 ]]; then
2426 die "${FUNCNAME}(): Missing files or directories"
2427 fi
2428
2429 while (($#)); do
2430 if [[ "$1" =~ ^($|(\.|\.\.|/)($|/)) ]]; then
2431 die "${FUNCNAME}(): Invalid argument '$1'"
2432 elif [[ -d "${myroot}/${1#/}" ]]; then
2433 mydirs+=("${myroot}/${1#/}")
2434 elif [[ -f "${myroot}/${1#/}" ]]; then
2435 myfiles+=("${myroot}/${1#/}")
2436 elif [[ -e "${myroot}/${1#/}" ]]; then
2437 eerror "${FUNCNAME}(): ${myroot}/${1#/} is not a regular file or directory"
2438 else
2439 eerror "${FUNCNAME}(): ${myroot}/${1#/} does not exist"
2440 fi
2441 shift
2442 done
2443
1991 # set additional opts 2444 # set additional opts
1992 myopts+=(-q) 2445 myopts+=(-q)
2446
2447 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
1993 2448
1994 ebegin "Compilation and optimization of Python modules for $(python_get_implementation) $(python_get_version)" 2449 ebegin "Compilation and optimization of Python modules for $(python_get_implementation) $(python_get_version)"
1995 if ((${#mydirs[@]})); then 2450 if ((${#mydirs[@]})); then
1996 "$(PYTHON ${PYTHON_ABI})" "${myroot}$(python_get_libdir)/compileall.py" "${myopts[@]}" "${mydirs[@]}" || return_code="1" 2451 "$(PYTHON ${PYTHON_ABI})" "${myroot}$(python_get_libdir)/compileall.py" "${myopts[@]}" "${mydirs[@]}" || return_code="1"
1997 "$(PYTHON ${PYTHON_ABI})" -O "${myroot}$(python_get_libdir)/compileall.py" "${myopts[@]}" "${mydirs[@]}" &> /dev/null || return_code="1" 2452 "$(PYTHON ${PYTHON_ABI})" -O "${myroot}$(python_get_libdir)/compileall.py" "${myopts[@]}" "${mydirs[@]}" &> /dev/null || return_code="1"
2453 _python_clean_compiled_modules "${mydirs[@]}"
1998 fi 2454 fi
1999 2455
2000 if ((${#myfiles[@]})); then 2456 if ((${#myfiles[@]})); then
2457 "$(PYTHON ${PYTHON_ABI})" "${myroot}$(python_get_libdir)/py_compile.py" "${myfiles[@]}" || return_code="1"
2458 "$(PYTHON ${PYTHON_ABI})" -O "${myroot}$(python_get_libdir)/py_compile.py" "${myfiles[@]}" &> /dev/null || return_code="1"
2001 python_mod_compile "${myfiles[@]}" 2459 _python_clean_compiled_modules "${myfiles[@]}"
2002 fi 2460 fi
2003 2461
2004 eend "${return_code}" 2462 eend "${return_code}"
2005 fi 2463 fi
2006} 2464}
2007 2465
2008# @FUNCTION: python_mod_cleanup 2466# @FUNCTION: python_mod_cleanup
2009# @USAGE: [directory|file] 2467# @USAGE: [--allow-evaluated-non-sitedir-paths] [--] <file|directory> [files|directories]
2010# @DESCRIPTION: 2468# @DESCRIPTION:
2011# Run with optional arguments, where arguments are Python modules. If none given, 2469# Delete orphaned byte-compiled Python modules corresponding to specified Python modules.
2012# it will look in /usr/lib/python[0-9].[0-9].
2013#
2014# It will recursively scan all compiled Python modules in the directories and
2015# determine if they are orphaned (i.e. their corresponding .py files are missing.)
2016# If they are, then it will remove their corresponding .pyc and .pyo files.
2017# 2470#
2018# This function can be used only in pkg_postrm() phase. 2471# This function can be used only in pkg_postrm() phase.
2019python_mod_cleanup() { 2472python_mod_cleanup() {
2473 _python_check_python_pkg_setup_execution
2020 _python_initialize_prefix_variables 2474 _python_initialize_prefix_variables
2021 _python_set_color_variables
2022 2475
2023 local path py_file PYTHON_ABI="${PYTHON_ABI}" SEARCH_PATH=() root 2476 local allow_evaluated_non_sitedir_paths="0" dir iterated_PYTHON_ABIS PYTHON_ABI="${PYTHON_ABI}" root search_paths=() sitedir
2024 2477
2025 # Check if phase is pkg_postrm(). 2478 # Check if phase is pkg_postrm().
2026 [[ "${EBUILD_PHASE}" != "postrm" ]] && die "${FUNCNAME}() can be used only in pkg_postrm() phase" 2479 [[ "${EBUILD_PHASE}" != "postrm" ]] && die "${FUNCNAME}() can be used only in pkg_postrm() phase"
2027 2480
2481 if _python_package_supporting_installation_for_multiple_python_abis; then
2482 if has "${EAPI:-0}" 0 1 2 3 && [[ -z "${PYTHON_ABIS}" ]]; then
2483 die "${FUNCNAME}(): python_pkg_setup() or python_execute_function() not called"
2484 fi
2485 iterated_PYTHON_ABIS="${PYTHON_ABIS}"
2486 else
2487 if has "${EAPI:-0}" 0 1 2 3; then
2488 iterated_PYTHON_ABIS="${PYTHON_ABI:-$(PYTHON --ABI)}"
2489 else
2490 iterated_PYTHON_ABIS="${PYTHON_ABI}"
2491 fi
2492 fi
2493
2028 # Strip trailing slash from ROOT. 2494 # Strip trailing slash from EROOT.
2029 root="${EROOT%/}" 2495 root="${EROOT%/}"
2030 2496
2031 if (($#)); then 2497 while (($#)); do
2032 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis; then 2498 case "$1" in
2499 --allow-evaluated-non-sitedir-paths)
2500 allow_evaluated_non_sitedir_paths="1"
2501 ;;
2502 --)
2503 shift
2504 break
2505 ;;
2506 -*)
2507 die "${FUNCNAME}(): Unrecognized option '$1'"
2508 ;;
2509 *)
2510 break
2511 ;;
2512 esac
2513 shift
2514 done
2515
2516 if [[ "${allow_evaluated_non_sitedir_paths}" == "1" ]] && ! _python_package_supporting_installation_for_multiple_python_abis; then
2517 die "${FUNCNAME}(): '--allow-evaluated-non-sitedir-paths' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2518 fi
2519
2520 if [[ "$#" -eq 0 ]]; then
2521 die "${FUNCNAME}(): Missing files or directories"
2522 fi
2523
2524 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis || _python_implementation || [[ "${CATEGORY}/${PN}" == "sys-apps/portage" ]]; then
2033 while (($#)); do 2525 while (($#)); do
2526 if [[ "$1" =~ ^($|(\.|\.\.|/)($|/)) ]]; then
2527 die "${FUNCNAME}(): Invalid argument '$1'"
2034 if ! _python_implementation && [[ "$1" =~ ^"${EPREFIX}"/usr/lib(32|64)?/python[[:digit:]]+\.[[:digit:]]+ ]]; then 2528 elif ! _python_implementation && [[ "$1" =~ ^/usr/lib(32|64)?/python[[:digit:]]+\.[[:digit:]]+ ]]; then
2035 die "${FUNCNAME}() does not support absolute paths of directories/files in site-packages directories" 2529 die "${FUNCNAME}(): Paths of directories / files in site-packages directories must be relative to site-packages directories"
2036 elif [[ "$1" =~ ^/ ]]; then 2530 elif [[ "$1" =~ ^/ ]]; then
2037 SEARCH_PATH+=("${root}/${1#/}") 2531 if _python_package_supporting_installation_for_multiple_python_abis; then
2532 if [[ "${allow_evaluated_non_sitedir_paths}" != "1" ]]; then
2533 die "${FUNCNAME}(): Absolute paths cannot be used in ebuilds of packages supporting installation for multiple Python ABIs"
2534 fi
2535 if [[ "$1" != *\$* ]]; then
2536 die "${FUNCNAME}(): '$1' has invalid syntax"
2537 fi
2538 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
2539 eval "search_paths+=(\"\${root}$1\")"
2540 done
2038 else 2541 else
2039 for PYTHON_ABI in ${PYTHON_ABIS-${PYTHON_ABI:-$(PYTHON --ABI)}}; do 2542 search_paths+=("${root}$1")
2040 SEARCH_PATH+=("${root}$(python_get_sitedir)/$1")
2041 done
2042 fi
2043 shift
2044 done
2045 else
2046 SEARCH_PATH=("${@#/}")
2047 SEARCH_PATH=("${SEARCH_PATH[@]/#/${root}/}")
2048 fi
2049 else
2050 local dir sitedir
2051 for dir in "${root}"/usr/lib*; do
2052 if [[ -d "${dir}" && ! -L "${dir}" ]]; then
2053 for sitedir in "${dir}"/python*/site-packages; do
2054 if [[ -d "${sitedir}" ]]; then
2055 SEARCH_PATH+=("${sitedir}")
2056 fi 2543 fi
2544 else
2545 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
2546 search_paths+=("${root}$(python_get_sitedir)/$1")
2057 done 2547 done
2058 fi 2548 fi
2549 shift
2059 done 2550 done
2060 for sitedir in "${root}"/usr/share/jython-*/Lib/site-packages; do 2551 else
2061 if [[ -d "${sitedir}" ]]; then 2552 # Deprecated part of python_mod_cleanup()
2062 SEARCH_PATH+=("${sitedir}") 2553 # ewarn
2063 fi 2554 # ewarn "Deprecation Warning: Usage of ${FUNCNAME}() in packages not supporting installation"
2064 done 2555 # ewarn "for multiple Python ABIs in EAPI <=2 is deprecated and will be disallowed on 2011-06-01."
2065 fi 2556 # ewarn "Use EAPI >=3 and call ${FUNCNAME}() with paths having appropriate syntax."
2557 # ewarn "The ebuild needs to be fixed. Please report a bug, if it has not been already reported."
2558 # ewarn
2066 2559
2067 for path in "${SEARCH_PATH[@]}"; do 2560 search_paths=("${@#/}")
2068 if [[ -d "${path}" ]]; then 2561 search_paths=("${search_paths[@]/#/${root}/}")
2069 find "${path}" "(" -name "*.py[co]" -o -name "*\$py.class" ")" -print0 | while read -rd ''; do
2070 if [[ "${REPLY}" == *[co] ]]; then
2071 py_file="${REPLY%[co]}"
2072 [[ -f "${py_file}" || (! -f "${py_file}c" && ! -f "${py_file}o") ]] && continue
2073 echo "${_BLUE}<<< ${py_file}[co]${_NORMAL}"
2074 rm -f "${py_file}"[co]
2075 elif [[ "${REPLY}" == *\$py.class ]]; then
2076 py_file="${REPLY%\$py.class}.py"
2077 [[ -f "${py_file}" || ! -f "${py_file%.py}\$py.class" ]] && continue
2078 echo "${_BLUE}<<< ${py_file%.py}\$py.class${_NORMAL}"
2079 rm -f "${py_file%.py}\$py.class"
2080 fi
2081 done
2082
2083 # Attempt to delete directories, which may be empty.
2084 find "${path}" -type d | sort -r | while read -r dir; do
2085 rmdir "${dir}" 2>/dev/null && echo "${_CYAN}<<< ${dir}${_NORMAL}"
2086 done
2087 elif [[ "${path}" == *.py && ! -f "${path}" ]]; then
2088 if [[ (-f "${path}c" || -f "${path}o") ]]; then
2089 echo "${_BLUE}<<< ${path}[co]${_NORMAL}"
2090 rm -f "${path}"[co]
2091 fi
2092 if [[ -f "${path%.py}\$py.class" ]]; then
2093 echo "${_BLUE}<<< ${path%.py}\$py.class${_NORMAL}"
2094 rm -f "${path%.py}\$py.class"
2095 fi
2096 fi 2562 fi
2097 done 2563
2564 _python_clean_compiled_modules "${search_paths[@]}"
2098} 2565}
2099 2566
2100# ================================================================================================ 2567# ================================================================================================
2101# ===================================== DEPRECATED FUNCTIONS ===================================== 2568# ===================================== DEPRECATED FUNCTIONS =====================================
2102# ================================================================================================ 2569# ================================================================================================
2103 2570
2104# @FUNCTION: python_version 2571# Scheduled for deletion on 2011-01-01.
2105# @DESCRIPTION:
2106# Run without arguments and it will export the version of python
2107# currently in use as $PYVER; sets PYVER/PYVER_MAJOR/PYVER_MINOR
2108python_version() { 2572python_version() {
2109 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis; then
2110 eerror "Use PYTHON() and/or python_get_*() instead of ${FUNCNAME}()."
2111 die "${FUNCNAME}() cannot be used in this EAPI"
2112 fi
2113
2114 _python_set_color_variables
2115
2116 if [[ "${FUNCNAME[1]}" != "distutils_python_version" ]]; then
2117 echo
2118 echo " ${_RED}*${_NORMAL} ${_RED}Deprecation Warning: ${FUNCNAME}() is deprecated and will be banned on 2010-07-01.${_NORMAL}"
2119 echo " ${_RED}*${_NORMAL} ${_RED}Use PYTHON() instead of python variable. Use python_get_*() instead of PYVER* variables.${_NORMAL}"
2120 echo " ${_RED}*${_NORMAL} ${_RED}The ebuild needs to be fixed. Please report a bug, if it has not been already reported.${_NORMAL}"
2121 echo
2122
2123 einfo &> /dev/null
2124 einfo "Deprecation Warning: ${FUNCNAME}() is deprecated and will be banned on 2010-07-01." &> /dev/null
2125 einfo "Use PYTHON() instead of python variable. Use python_get_*() instead of PYVER* variables." &> /dev/null 2573 eerror "Use PYTHON() instead of python variable. Use python_get_*() instead of PYVER* variables."
2126 einfo "The ebuild needs to be fixed. Please report a bug, if it has not been already reported." &> /dev/null 2574 die "${FUNCNAME}() is banned"
2127 einfo &> /dev/null
2128 fi
2129
2130 [[ -n "${PYVER}" ]] && return 0
2131 local tmpstr
2132 python="${python:-${EPREFIX}/usr/bin/python}"
2133 tmpstr="$(EPYTHON= ${python} -V 2>&1 )"
2134 export PYVER_ALL="${tmpstr#Python }"
2135 export PYVER_MAJOR="${PYVER_ALL:0:1}"
2136 export PYVER_MINOR="${PYVER_ALL:2:1}"
2137 if [[ "${PYVER_ALL:3:1}" == "." ]]; then
2138 export PYVER_MICRO="${PYVER_ALL:4}"
2139 fi
2140 export PYVER="${PYVER_MAJOR}.${PYVER_MINOR}"
2141} 2575}
2142 2576
2143# @FUNCTION: python_mod_exists 2577# Scheduled for deletion on 2011-01-01.
2144# @USAGE: <module>
2145# @DESCRIPTION:
2146# Run with the module name as an argument. It will check if a
2147# Python module is installed and loadable. It will return
2148# TRUE(0) if the module exists, and FALSE(1) if the module does
2149# not exist.
2150#
2151# Example:
2152# if python_mod_exists gtk; then
2153# echo "gtk support enabled"
2154# fi
2155python_mod_exists() { 2578python_mod_exists() {
2156 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis; then
2157 eerror "Use USE dependencies and/or has_version() instead of ${FUNCNAME}()." 2579 eerror "Use USE dependencies and/or has_version() instead of ${FUNCNAME}()."
2158 die "${FUNCNAME}() cannot be used in this EAPI" 2580 die "${FUNCNAME}() is banned"
2159 fi
2160
2161 echo
2162 echo " ${_RED}*${_NORMAL} ${_RED}Deprecation Warning: ${FUNCNAME}() is deprecated and will be banned on 2010-07-01.${_NORMAL}"
2163 echo " ${_RED}*${_NORMAL} ${_RED}Use USE dependencies and/or has_version() instead of ${FUNCNAME}().${_NORMAL}"
2164 echo " ${_RED}*${_NORMAL} ${_RED}The ebuild needs to be fixed. Please report a bug, if it has not been already reported.${_NORMAL}"
2165 echo
2166
2167 einfo &> /dev/null
2168 einfo "Deprecation Warning: ${FUNCNAME}() is deprecated and will be banned on 2010-07-01." &> /dev/null
2169 einfo "Use USE dependencies and/or has_version() instead of ${FUNCNAME}()." &> /dev/null
2170 einfo "The ebuild needs to be fixed. Please report a bug, if it has not been already reported." &> /dev/null
2171 einfo &> /dev/null
2172
2173 if [[ "$#" -ne 1 ]]; then
2174 die "${FUNCNAME}() requires 1 argument"
2175 fi
2176 "$(PYTHON ${PYTHON_ABI})" -c "import $1" &> /dev/null
2177} 2581}
2178 2582
2179# @FUNCTION: python_tkinter_exists 2583# Scheduled for deletion on 2011-01-01.
2180# @DESCRIPTION:
2181# Run without arguments, checks if Python was compiled with Tkinter
2182# support. If not, prints an error message and dies.
2183python_tkinter_exists() { 2584python_tkinter_exists() {
2184 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis; then
2185 eerror "Use PYTHON_USE_WITH=\"xml\" and python_pkg_setup() instead of ${FUNCNAME}()." 2585 eerror "Use PYTHON_USE_WITH=\"xml\" and python_pkg_setup() instead of ${FUNCNAME}()."
2186 die "${FUNCNAME}() cannot be used in this EAPI" 2586 die "${FUNCNAME}() is banned"
2187 fi
2188
2189 if [[ "${FUNCNAME[1]}" != "distutils_python_tkinter" ]]; then
2190 echo
2191 echo " ${_RED}*${_NORMAL} ${_RED}Deprecation Warning: ${FUNCNAME}() is deprecated and will be banned on 2010-07-01.${_NORMAL}"
2192 echo " ${_RED}*${_NORMAL} ${_RED}Use PYTHON_USE_WITH=\"xml\" and python_pkg_setup() instead of ${FUNCNAME}().${_NORMAL}"
2193 echo " ${_RED}*${_NORMAL} ${_RED}The ebuild needs to be fixed. Please report a bug, if it has not been already reported.${_NORMAL}"
2194 echo
2195
2196 einfo &> /dev/null
2197 einfo "Deprecation Warning: ${FUNCNAME}() is deprecated and will be banned on 2010-07-01." &> /dev/null
2198 einfo "Use PYTHON_USE_WITH=\"xml\" and python_pkg_setup() instead of ${FUNCNAME}()." &> /dev/null
2199 einfo "The ebuild needs to be fixed. Please report a bug, if it has not been already reported." &> /dev/null
2200 einfo &> /dev/null
2201 fi
2202
2203 if ! "$(PYTHON ${PYTHON_ABI})" -c "from sys import version_info
2204if version_info[0] == 3:
2205 import tkinter
2206else:
2207 import Tkinter" &> /dev/null; then
2208 eerror "Python needs to be rebuilt with tkinter support enabled."
2209 eerror "Add the following line to '${EPREFIX}/etc/portage/package.use' and rebuild Python"
2210 eerror "dev-lang/python tk"
2211 die "Python installed without support for tkinter"
2212 fi
2213} 2587}
2214 2588
2215# @FUNCTION: python_mod_compile 2589# Scheduled for deletion on 2011-04-01.
2216# @USAGE: <file> [more files ...]
2217# @DESCRIPTION:
2218# Given filenames, it will pre-compile the module's .pyc and .pyo.
2219# This function can be used only in pkg_postinst() phase.
2220#
2221# Example:
2222# python_mod_compile /usr/lib/python2.3/site-packages/pygoogle.py
2223#
2224python_mod_compile() { 2590python_mod_compile() {
2225 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis; then
2226 eerror "Use python_mod_optimize() instead of ${FUNCNAME}()." 2591 eerror "Use python_mod_optimize() instead of ${FUNCNAME}()."
2227 die "${FUNCNAME}() cannot be used in this EAPI" 2592 die "${FUNCNAME}() is banned"
2228 fi
2229
2230 _python_initialize_prefix_variables
2231
2232 local f myroot myfiles=()
2233
2234 # Check if phase is pkg_postinst()
2235 [[ "${EBUILD_PHASE}" != "postinst" ]] && die "${FUNCNAME}() can be used only in pkg_postinst() phase"
2236
2237 # strip trailing slash
2238 myroot="${EROOT%/}"
2239
2240 # respect ROOT
2241 for f in "$@"; do
2242 [[ -f "${myroot}/${f}" ]] && myfiles+=("${myroot}/${f}")
2243 done
2244
2245 if ((${#myfiles[@]})); then
2246 "$(PYTHON ${PYTHON_ABI})" "${myroot}$(python_get_libdir)/py_compile.py" "${myfiles[@]}"
2247 "$(PYTHON ${PYTHON_ABI})" -O "${myroot}$(python_get_libdir)/py_compile.py" "${myfiles[@]}" &> /dev/null
2248 else
2249 ewarn "No files to compile!"
2250 fi
2251} 2593}

Legend:
Removed from v.1.95  
changed lines
  Added in v.1.105

  ViewVC Help
Powered by ViewVC 1.1.20